#!/usr/bin/perl
#
# Jeremy Chartier, <jeremy.chartier@free.fr>
# Date: 2003/08/21
# Revision: 2.0rc2
# 

# General Librairies - Never comment
use Getopt::Long;		# use Getopt for options
use Socket;                     # use socket for resolving domain name from IP
# Graphical Tool Kit Librairies
use Tk; $TK = 1;                    # use Tk for using GUI
use Tk::NoteBook; $TK = 2;		# use Tk::NoteBook for using GUI
# GD Librairies for charts
use GD::Graph::pie; $GD = 1;
use GD::Graph::bars; $GD = 2;
use GD::Graph::lines; $GD = 3;
use GD::Graph::area; $GD = 4;

# Main variables
$domains_file = "/tmp/domains";	$DOMAINS = 1;	# Path to find Domain file
$rules_file = "/tmp/rules"; $RULES = 1;		# Path to find Rules file
$html_directorie = "/tmp/";			# Default output directories (HTML output exclusively)
$tmpout_file = "/tmp/~snortalog.tmp";		# Default tempory file (GUI exclusively)

$legende_red = "Dangerous connections (continue your investigations in this way)";
$legende_green = "Warning connections (strange, may be it will be interesting to search)";
$legende_black = "Not dangerous alert";

$addr_len = 15;
$nb_len = 6;
$port_len = 5;
$attack_len = 70;
$class_len = 60;
$resolve_len = 50;
$hour_len = 2;
$graph_len = 75;
$prior_len = 1;
$sever_len = 7;
$domain_len = 30;
$ether_len = 10;
$version = "2.0.0";
$datever = "2003/09/29 10:13:16";
$date = `date '+%Y/%m/%d at %H:%M:%S'`;
$maxday = 1; $maxmonth = 1; $maxhour = 0; $maxmin = 0; $maxsec = 0;
$minday = 31; $minmonth = 12; $minhour = 23; $minmin = 59; $minsec = 59;
$graph_date = `date +%Y%m%d%H%M`;
chomp $graph_date;

Getopt::Long;

GetOptions( \%opt,
	'd',
	'r',
	'i',
	'g=s',
	'h=s',
	'u=s',
	'n=i',
	'c',
	'x',
	'file=s',
	'ether=s',
	'class',
	'src',
	'dst',
	'class_attack',
	'attack',
	'dport',
	'dport_attack',
	'nids',
	'stateful',
	'interfaces',
	'severity',
	'src_attack',
	'dst_attack',
	'hour',
	'proto',
	'hour_attack',
	'daily_event',
	'domain_src',
	'src_dst_attack',
	'portscan',
	'priority',
	'src_dport',
	'dst_dport',
	'rules',
	'reasons',
	'actions',
	'report',
	'genref=s'
	) or usage();
	

init_monthday();
init_daymonth();

if ($opt{x}) {
	if ( $TK == 2 ) {
	$top = new MainWindow;

	$menu = $top->Menu;
	$file_menu = $menu->cascade(-label => '~File', -tearoff => 0);
	$reportsids_menu  = $menu->cascade(-label => '~Reports IDS', -tearoff => 0);
	$reportsfw_menu  = $menu->cascade(-label => '~Reports FW', -tearoff => 0);
	$utils_menu  = $menu->cascade(-label => '~Utils', -tearoff => 0);
	$help_menu  = $menu->cascade(-label => '~Help', -tearoff => 0);

	$file_submenu = $top->Menu(-tearoff => 0, -menuitems => [
		[command => "~Exit", -command => sub { exit } ],]);

	$reportsids_submenu = $top->Menu(-tearoff => 0, -menuitems => [
		[command => "Top IP Sources", -command => \&x_attack_src],
		[command => "Top IP Destinations", -command => \&x_attack_dst],
		[command => "Top IP Source<-->Attacks", -command => \&x_src_attack],
		[command => "Top IP Desination<-->Attacks", -command => \&x_dst_attack],
		[command => "Top Source<-->Destination<-->Attacks", -command => \&x_src_dst_attack],
		[command => "Top Attacks", -command => \&x_attack],
		[command => "Top Hour", -command => \&x_hour],
		[command => "Top Classfication", -command => \&x_class],
		[command => "Top Stateful", -command => \&x_stateful],
		[command => "Top Nids", -command => \&x_nids],
		[command => "Top Severity", -command => \&x_severity],
		[command => "Top Daily Event", -command => \&x_daily_event],
		[command => "Top Destination Port Attack", -command => \&x_dport],
		[command => "Top Destination Port<--> Attack", -command => \&x_dport_attack],
		[command => "Top Hour<-->Attacks", -command => \&x_same_hour_attack],
		[command => "Top Domain Source", -command => \&x_domain_src],
		[command => "Top Interfaces", -command => \&x_interfaces],
		[command => "Top Protocoles", -command => \&x_proto],
		[command => "Portscans", -command => \&x_portscan],
		[command => "Full Report", -command => \&x_report],]);

	$reportsfw_submenu = $top->Menu(-tearoff => 0, -menuitems => [
		[command => "Top IP Sources", -command => \&x_attack_src],
		[command => "Top IP Destinations", -command => \&x_attack_dst],
		[command => "Top IP Sources <--> Destination Port", -command => \&x_src_dport],
		[command => "Top IP Destinations <--> Destination Port", -command => \&x_dst_dpor_dport],
		[command => "Top Hour", -command => \&x_hour],
		[command => "Top Nids", -command => \&x_nids],
		[command => "Top Daily Event", -command => \&x_daily_event],
		[command => "Top Domain Source", -command => \&x_domain_src],
		[command => "Top Interfaces", -command => \&x_interfaces],
		[command => "Top Protocoles", -command => \&x_proto],
		[command => "Portscans", -command => \&x_portscan],
		[command => "Top actions", -command => \&x_actions],
		[command => "Top reasons", -command => \&x_reasons],
		[command => "Top rules", -command => \&x_rules],
		[command => "Full Report", -command => \&x_report],]);

	$utils_submenu = $top->Menu(-tearoff => 0, -menuitems => [
		[command => "~Clear Screen", -command => \&clear_screen ],]);

	$help_submenu = $top->Menu(-tearoff => 0, -menuitems => [
		[command => "~About", -command => \$x_popup],]);

	$file_menu->configure(-menu => $file_submenu);
	$reportsids_menu->configure(-menu => $reportsids_submenu);
	$reportsfw_menu->configure(-menu => $reportsfw_submenu);
	$utils_menu->configure(-menu => $utils_submenu);
	$help_menu->configure(-menu => $help_submenu);


	$top->configure(title => "Snortalog V2.0rc1", width => 895, height => 520, menu => $menu);


	$note = $top->NoteBook()->place(-x => 10, -y => 5);
	$page1 = $note->add("page1", label => 'Options');
	$page2 = $note->add("page2", label => 'Result');
	$page3 = $note->add("page3", label => 'Configuration');



	$label_file = $page1->Label(text => 'File :')->place(-x => 10, -y => 10);
	#$entry1 = $page1->Entry(width => 30, background => 'gray')->place(-x => 60, -y => 10);
	$entry_file = $page1->Entry(width => 30, background => 'gray')->place(-x => 60, -y => 10);
	$button_load = $page1->Button( text => 'Load File', command => \&xload)->place(-x => 300, -y => 8);

	$label4 = $page1->Label(width => 65, height => 15, relief => 'groove')->place(-x => 400, -y => 20);
	$label_result_option = $page1->Label(text => 'Result Options :')->place(-x => 405, -y => 10);
	$label5 = $page1->Label(width => 65, height => 14, relief => 'groove')->place(-x => 400, -y => 250);
	$label_html_option = $page1->Label(text => 'Html Options :')->place(-x => 405, -y => 240);

	$optn = 0;                     # Starting value
	$opth = 0;                     # Starting value
	$optu = 0;                     # Starting value
	$optg = 0;                     # Starting value
	$opti = 0;                     # Starting value
	$optr = 0;                     # Starting value
	$optd = 0;                     # Starting value
	$optc = 0;                     # Starting value
	$opt_i = $page1->Checkbutton ( variable => \$opti, text => 'Reverse the Result')->place(-x => 470, -y => 40);
	$opt_r = $page1->Checkbutton ( variable => \$optr, text => 'Resolve Addresses')->place(-x => 470, -y => 70);
	$opt_d = $page1->Checkbutton ( variable => \$optc, text => 'Resolve Domain')->place(-x => 470, -y => 100);
	$opt_d = $page1->Checkbutton ( variable => \$optd, text => 'Debug Mode')->place(-x => 470, -y => 130);
	$opt_n = $page1->Checkbutton ( variable => \$optn, text => 'Specify number of Occurences :')->place(-x => 470, -y => 160);
	$entry_option_n = $page1->Entry(width => 5, background => 'gray')->place(-x => 700, -y => 160);
	$opt_h = $page1->Checkbutton ( variable => \$opth, text => 'Specify HTML Output :')->place(-x => 470, -y => 270);
	$entry_option_h = $page1->Entry(width => 15, background => 'gray')->place(-x => 700, -y => 270);
	$opt_g = $page1->Checkbutton ( variable => \$optg, text => 'Specify Graph Format :')->place(-x => 470, -y => 300);
 	$listbox_option_g = $page1->Listbox(width => 15, height => 3, background => 'gray')->place(-x => 700, -y => 300);
	$listbox_option_g->insert('end', 'gif','png','jpg');
	$listbox_option_g->selectionSet(0);

	#$text1  = $page2->Scrolled('Text', width => 120, height => 35, -bg => 'gray', -scrollbars => 'e', -wrap =>'word')->pack;
	$scrolled_result  = $page2->Scrolled('Text', width => 120, height => 35, -bg => 'gray', -scrollbars => 'e', -wrap =>'word')->pack;
	#$text2 = $page1->Label(text => 'Status :')->place(-x => 10, -y => 40);
	$label_status = $page1->Label(text => 'Status :')->place(-x => 10, -y => 40);
	$scrolled_status  = $page1->Scrolled('Text', width => 49, height => 13, -bg => 'gray', -scrollbars => 'e', -wrap =>'word')->place(-x => 10, -y => 60);
	$label_debug = $page1->Label(text => 'Debug :')->place(-x => 10, -y => 240);
	$scrolled_debug  = $page1->Scrolled('Text', width => 49, height => 14, -bg => 'gray', -scrollbars => 'e', -wrap =>'word')->place(-x => 10, -y => 260);

	$label_domains_file = $page3->Label(text => 'Path to Domain File :')->place(-x => 30, -y => 40);
	$entry_domains_file = $page3->Entry(width => 30, background => 'gray')->place(-x => 250, -y => 40);
	$entry_domains_file->insert('end', "$domains_file");
	$label_rules_file = $page3->Label(text => 'Path to Rules File :')->place(-x => 30, -y => 80);
	$entry_rules_file = $page3->Entry(width => 30, background => 'gray')->place(-x => 250, -y => 80);
	$entry_rules_file->insert('end', "$rules_file");
	$label_tmpout_file = $page3->Label(text => 'Specify the Tempory File :')->place(-x => 30, -y => 120);
	$entry_tmpout_file = $page3->Entry(width => 30, background => 'gray')->place(-x => 250, -y => 120);
	$entry_tmpout_file->insert('end', "$tmpout_file");
	$label_html_directorie = $page3->Label(text => 'Specify the HTML directorie :')->place(-x => 30, -y => 160);
	$entry_html_directorie = $page3->Entry(width => 30, background => 'gray')->place(-x => 250, -y => 160);
	$entry_html_directorie->insert('end', "$html_directorie");

	MainLoop();
	} else {
		print "GUI not available, please to check your installation !!!\n";
		print "\n";
		print "Uncomment this variables :\n";
		print "\tuse Tk; \$TK = 1;\n";
		print "\tuse Tk::NoteBook; \$TK = 2;\n";
		print "\n";
		print "And verify you have the good perl librairies.\n";
	}

} else { 
	# initialize variables
	$opt_i = 0;
	$opt_r = 0;
	$opt_h = 0;
	$opt_u = 0;
	$opt_g = 0;
	$opt_d = 0;
	$opt_c = 0;
	$opt_n = 0;
	# set variables
	$opt_i = 1 if $opt{i}; 
	$opt_r = 1 if $opt{r}; 
	$opt_h = 1 if $opt{h}; 
	$opt_u = 1 if $opt{u}; 
	$opt_d = 1 if $opt{d}; 
	$opt_g = 1 if $opt{g}; 
	$opt_c = 1 if $opt{c}; 
	$opt_n = 1 if $opt{n}; 
	$val_opt_n = $opt{n} if ( $opt_n == 1 ); 
	$val_opt_h = $opt{h} if ( $opt_h == 1 ); 
	$val_opt_g = $opt{g} if ( $opt_g == 1 ); 
	$val_opt_u = $opt{u} if ( $opt_u == 1 );
	$val_opt_file = $opt{file} if ( $opt{file} );
	$graph_name = $val_opt_h;
	$graph_name =~ /^([\w||\d||\-||\_]+)/;
	$graph_name = $1;

	if ( $opt{genref} ) {
		print "The Signature Rules File was generated successfully : $opt{genref}\n";
		load();
		exit;
	} else {
		if ( $opt{file} ) {
			xload();
		} else {
			load();
		}
		print_head();
		print_summary();
		if ( $opt{src} ) { attack_src() };
		if ( $opt{dst} ) { attack_dst() };
		if ( $opt{src_attack} ) { same_src_attack() };
		if ( $opt{dst_attack} ) { same_dst_attack() };
		if ( $opt{src_dst_attack} ) { same_src_dst_attack() };
		if ( $opt{attack} ) { attack() };
		if ( $opt{class} ) { same_class() };
		if ( $opt{severity} ) { severity() };
		if ( $opt{daily_event} ) { daily_event() if ($minmonth ne $maxmonth) || ($minday < $maxday) };
		if ( $opt{hour} ) { hour() };
		if ( $opt{hour_attack} ) { same_hour_attack() };
		if ( $opt{dport} ) { dport() };
		if ( $opt{dport_attack} ) { dport_attack() };
		if ( $opt{nids} ) { nids() if (keys(%s13) > 1) };
		if ( $opt{stateful} ) { stateful() if ($anomaly > 0) };
		if ( $opt{domain_src} ) { domain_src() };
		if ( $opt{proto} ) { proto() };
		if ( $opt{portscan} ) { portscan() if ( $totalscan > 1 ) };
		if ( $opt{interfaces} ) { interfaces() if ( keys(%s1) > 1 ) };
		if ( $opt{reasons} ) { reasons() if ( keys(%s12) > 1 ) };
		if ( $opt{actions} ) { actions() if ( keys(%s14) > 1 ) };
		if ( $opt{rules} ) { rules() if ( keys(%s21) > 1 ) };
		if ( $opt{src_dport} ) { same_src_dport() };
		if ( $opt{dst_dport} ) { same_dst_dport() };
		if ( $opt{report} ) {
			print_menu();
			if ( $logfw == 1 ) {
				proto();
				hour();
				daily_event() if ($minmonth ne $maxmonth) || ($minday < $maxday);
				dport();
				nids() if (keys(%s13) > 1);
				interfaces() if (keys(%s1) > 1);
				domain_src() if ( $opt{c} );
				attack_src();
				attack_dst();
				same_src_dport();
				same_dst_dport();
				reasons() if ( keys(%s12) > 1 );
				actions() if ( keys(%s14) > 1 );
				rules() if ( keys(%s21) > 1 );
			} 
				if ( $logids eq 1 ) {
				proto();
				severity();
				hour();
				daily_event() if ($minmonth ne $maxmonth) || ($minday < $maxday);
				dport();
				nids() if (keys(%s13) > 1);
				interfaces() if (keys(%s1) > 1);
				domain_src() if ( $opt{c} );
				attack_src();
				same_src_attack();
				attack_dst();
				same_dst_attack();
				same_src_dst_attack();
				attack();
				same_class();
				same_hour_attack();
				dport_attack();
				stateful() if ($anomaly > 0);
				portscan() if ( $totalscan > 1 );
			}
		}
		print_footer();
	}
}






sub get_opt {
	$opt_i = $opti;
	$opt_r = $optr;
	$opt_h = $opth;
	$opt_g = $optg;
	$opt_n = $optn;
	$opt_d = $optd;
	$opt_c = $optc;
	$listbox_option_g->selectionSet(0);
	$val_opt_file = $entry_file->get();
	$val_opt_n = $entry_option_n->get() if ($opt_n == 1);
	$val_opt_h = $entry_option_h->get() if ($opt_h == 1);
	$index_opt_g = $listbox_option_g->curselection;
	$val_opt_g = $listbox_option_g->get($index_opt_g);
	$val_opt_u = $entry_html_directorie->get();
	$scrolled_debug->delete('1.0','end');
	$scrolled_status->delete('1.0','end');
	$domains_file = $entry_domains_file->get();
	$rules_file = $entry_rules_file->get();
	$tmpout_file = $entry_tmpout_file->get();
	# extract the name of output file for graph file name
	$graph_name = $val_opt_h;
	$graph_name =~ /^([\w||\d]+)/;
	$graph_name = $1;
}


















sub xload {
$logtotal = 0;
$logdrop = 0;
$logfw = 0;
$logids = 0;
get_opt() if ( ! $opt{file} );
open (FILE, $val_opt_file) or die "Can not open $val_opt_file $!\n";
$scrolled_status->insert('end', "Loading $val_opt_file :\t\t\t") if ( ! $opt{file} );
### UNDEF VARIABLES
undef @result;
undef %s0;
undef %s1;
undef %s2;
undef %s3;
undef %s4;
undef %s5;
undef %s6;
undef %s7;
undef %s8;
undef %s9;
undef %s10;
undef %s11;
undef %s12;
undef %s13;
undef %s14;
undef %s15;
undef %s16;
undef %s17;
undef %s18;
undef %s19;
undef %s20;
undef %s21;
undef %s22;
undef %s23;
undef %s40;		### For domain hash table
undef %s41;		### For IDS portscan hash table

while (<FILE>) {
my $alert = {};
chomp;
# if the line is blank, go to the next one
next if $_ eq "";
++$logtotal;

# This is ipf log 
if ($_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+(\S+)\s+ipmon\[\d+\]\:\s+\S+\s+(\S+)\s+\S+\s\S+\s+([\d\.]+)\,(\d+)\s+\-\>\s+([\d\.]+)\,(\d+)\s+\S+\s+(\S+)*// || s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+(\S+)\s+ipmon\[\d+\]\:\s+\S+\s+\S+\s(\S+)\s+\S+\s\S+\s+([\d\.]+)\,(\d+)\s+\-\>\s+([\d\.]+)\,(\d+)\s+\S+\s+(\S+)*//) {
	$alert->{MON} = $1;    $alert->{DAY} = $2;    $alert->{HOUR} = $3; 
	$alert->{MIN} = $4;    $alert->{SEC} = $5;    $alert->{HOST} = $6;  
	$alert->{ETHER} = $7;    $alert->{SADDR} = $8;    $alert->{SPORT} = $9;  
	$alert->{DADDR} = $10;    $alert->{DPORT} = $11;    $alert->{PROTO} = $12;  $alert->{TYPE} = "alert";
	if ( ( $opt{ether} ) && ( $opt{ether} ne "$7" ) ) {
		next;
	}
	search_date($monthday{$1}, $2, $3, $4, $5);
	process_data($alert); $logfw = 1;
	#print "$1\t$2\t$3\t$4\t$5\t$6\t$7\t$8\t$9\t$10\t$11\t$12\n";
} elsif ($_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+(\S+)\s+ipmon\[\d+\]\:\s+\S+\s+(\S+)\s+\S+\s\S+\s+([\d\.]+)\s+\-\>\s+([\d\.]+)\s+\S+\s+(\S+)*//) {
	$alert->{MON} = $1;    $alert->{DAY} = $2;    $alert->{HOUR} = $3; 
	$alert->{MIN} = $4;    $alert->{SEC} = $5;    $alert->{HOST} = $6;  
	$alert->{ETHER} = $7;    $alert->{SADDR} = $8;  
	$alert->{DADDR} = $9;    $alert->{PROTO} = $10;  $alert->{TYPE} = "alert";
	if ( ( $opt{ether} ) && ( $opt{ether} ne "$7" ) ) {
		next;
	}
	search_date($monthday{$1}, $2, $3, $4, $5);
	process_data($alert); $logfw = 1;
 


# This is fw1 log 
} elsif ( $_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+\S+\s+\S+\s+\S+\s+(\S+)\s+(\S+)\s+[\>|\<](\S+)\s+proto\s+(\S+)\s+src\s+([\d\.]+)\s+dst\s+([\d\.]+)\s+//ox ) {
	$alert->{MON} = $1;    $alert->{DAY} = $2;    $alert->{HOUR} = $3;
	$alert->{MIN} = $4;    $alert->{SEC} = $5;    $alert->{ACTION} = $6;    $alert->{HOST} = $7;
	$alert->{ETHER} = $8;    $alert->{SADDR} = $10;         $alert->{DADDR} = $11;  $alert->{PROTO} = $9;  $alert->{TYPE} = "alert";
	if ( ( $opt{ether} ) && ( $opt{ether} ne "$8" ) ) {
		next;
	}
	search_date($monthday{$1}, $2, $3, $4, $5);

	if ( $_ =~ s/^service\s+(\S+)\s+s_port\s+(\S+)\s+//ox ) {
       		$alert->{DPORT} = $1;    $alert->{SPORT} = $2;
	}
	if ( $_ =~ s/^rule\s+(\d+)\s+reason:\s+//ox) {
       		$alert->{REASON} = $_; $alert->{RULE} = $1;
       	} elsif ( $_ =~ s/^rule\s+(\d+)\s+//ox) {
       		$alert->{REASON} = $_; $alert->{RULE} = $1;
       	} elsif ($_ =~ s/^len\s+\d+\s+rule\s+(\d+)//ox) {
       		$alert->{REASON} = "normal connection dropped"; $alert->{RULE} = $1;
       	}
	process_data($alert); $logfw = 1;



	# This is fw1 NG log (DAEMON message ONLY)
	} elsif ( $_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+\S+\s+\S+\s+\[[^\[|^\]]*?\]\s+\d+\:\d+\:\d+\s+(\S+)\s+([\d\.]+)\s+[\>|\<](\S+)\s+sys_message\:[^\:|^\;]*?\;//ox ) {
		$alert->{MON} = $monthday{$1}; $alert->{DAY} = $2; $alert->{HOUR} = $3;
		$alert->{MIN} = $4; $alert->{SEC} = $5;	$alert->{ACTION} = $6; $alert->{HOST} = $7;
		$alert->{ETHER} = $8; $alert->{REASON} = $9; $alert->{RULE} = 0; $alert->{TYPE} = "alert";
		search_date($monthday{$1}, $2, $3, $4, $5);
		process_data($alert); $logfw = 1;



	# This is fw1 NG log (ICMP ONLY)
	} elsif ( $_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+\S+\s+\S+\s+\[[^\[|^\]]*?\]\s+\d+\:\d+\:\d+\s+(\S+)\s+([\d\.]+)\s+[\>|\<](\S+)\s+\w+\:[^\:|^\;]*?\;\s+src\:\s+([\d\.]+)\;\s+dst\:\s+([\d\.]+)\;\s+proto\:\s+(\w+)\;\s+icmp-type\:\s+\d+\;\s+icmp-code\:\s+\d+\;\s+//ox ) {
		$alert->{MON} = $monthday{$1}; $alert->{DAY} = $2; $alert->{HOUR} = $3;
		$alert->{MIN} = $4; $alert->{SEC} = $5;	$alert->{ACTION} = $6; $alert->{HOST} = $7;
		$alert->{ETHER} = $8; $alert->{SADDR} = $9; $alert->{DADDR} = $10; $alert->{PROTO} = $11;
		$alert->{TYPE} = "alert";
#		print "$1\t$2\t$3\t$4\t$5\t$6\t$7\t$8\t$9\t$10\t$11\t$12";
#		print "$_\n";
		search_date($monthday{$1}, $2, $3, $4, $5);
		if ( $_ =~ s/rule\:\s+(\d+)\;//ox ) {
       	   		$alert->{RULE} = $1;
		} else {
       	   		$alert->{RULE} = 0;
       		}
		if ( $_ =~ s/message_info\:\s+([^\:|^\;]*?)\;//ox) {
       	   		$alert->{REASON} = $1;
		} else {
			$alert->{REASON} = "normal connection dropped";
		}
		if ( ( $opt{ether} ) && ( $opt{ether} ne "$8" ) ) {
			next;
		}
		process_data($alert); $logfw = 1;


	# This is fw1 NG log (EXCEPT ICMP)
	} elsif ( $_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+\S+\s+\S+\s+\[[^\[|^\]]*?\]\s+\d+\:\d+\:\d+\s+(\S+)\s+([\d\.]+)\s+[\>|\<](\S+)\s+\w+\:[^\:|^\;]*?\;\s+src\:\s+([\d\.]+)\;\s+s_port\:\s+([\d|\w|\-|\d]+)\;\s+dst\:\s+([\d\.]+)\;\s+service\:\s+([\d|\w|\-|\d]+)\;\s+proto\:\s+(\w+)\;\s+//ox ) {
		$alert->{MON} = $monthday{$1}; $alert->{DAY} = $2; $alert->{HOUR} = $3;
		$alert->{MIN} = $4; $alert->{SEC} = $5;	$alert->{ACTION} = $6; $alert->{HOST} = $7;
		$alert->{ETHER} = $8; $alert->{SADDR} = $9; $alert->{SPORT} = $10; $alert->{DADDR} = $11;
		$alert->{DPORT} = $12; $alert->{PROTO} = $13; $alert->{RULE} = $13; $alert->{TYPE} = "alert";
		search_date($monthday{$1}, $2, $3, $4, $5);
		if ( $_ =~ s/rule\:\s+(\d+)\;//ox) {
       	   		$alert->{RULE} = $1;
		} else {
       	   		$alert->{RULE} = 0;
       		}
		if ( $_ =~ s/message_info\:\s+([^\:|^\;]*?)\;//ox) {
       	   		$alert->{REASON} = $1;
		} else {
			$alert->{REASON} = "normal connection dropped";
       		}
		if ( ( $opt{ether} ) && ( $opt{ether} ne "$8" ) ) {
			next;
		}
		process_data($alert); $logfw = 1;




#
#  test if the log correspond to the first line of snort's full alert
#
} elsif ( $_ =~ /^\[\*\*\]/ ) {

	if ( $_ =~ m/^\[\*\*\]\s+\[[0-9:]+\]\s\(spp_portscan\d\)\sPortscan\sdetected\sfrom\s([\d\.]+)/ox || m/^\[\*\*\]\s+\[[0-9:]+\]\sspp_portscan:\s+End\sof\sportscan\sfrom\s([\d\.]+)/ox) { # portscan
		$alert->{SADDR} = $1; $alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "portscan"; $alert->{SEVERITY} = "unknown";
		process_data($alert); next; $logids = 1;
	} elsif ( $_ =~ m/spp_portscan/ox || m/Spade/ox) {
		next; $logids = 1;
	} else {
		s/\s*\[\*\*\]\s*//og;
		s/\s*\[[0-9:]+\]\s*//o;
		#
		#  verify if there are an interface in the log line
		#  anf if it's the case, add interface in databse
		#  
		s/\<([^\<|^\>]*?)\>//og;  # Get interface
		$ETHER = $1;
		if ( ( $opt{ether} ) && ( $opt{ether} ne "$1" ) ) {
			next; next; next;
		}
		$SIG = $_;
		next;
	}


#
#  test if the log correspond to the second line of snort's full alert
#
} elsif ( $_ =~ m/^\[Classification\:([^\[|^\]]*?)\]\s+\[Priority\:\s+(\d{1})\]/ox ) {
	if ($2 == 1) {
		$severity = "high";
	} elsif ($2 == 2) {
		$severity = "medium";
	} elsif ($2 == 3) {
		$severity = "low";
	} else {
		$severity = "unknown"
	}
	$CLASS = $1;
	$PRIORITY = $2;
	$SEVERITY = $severity;
	next;



#
#  test if the log correspond to the third line of snort's full alert
#
} elsif ( $_ =~ /^(\d{2})\/(\d{2})\-(\d{2})\:(\d{2})\:(\d{2})\.\d+\s+([\d\.]+)\:?([\d]*)\s[\-\>]+\s([\d\.]+)\:?([\d]*)/) {
	$MON = $1; $DAY = $2; $HOUR = $3; $MIN = $4; $SEC = $5; $SADDR = $6; $SPORT = $7; $DADDR = $8; $DPORT = $9;
	search_date($1, $2, $3, $4, $5);
	next;




#
#  test if the log correspond to the fourth line of snort's full alert
#
} elsif ( $_ =~ m/^(\w+)\s.+ID:\d+\sIpLen\:\d+\sDgmLen\:\d+/ox ) {
	$PROTO = $1; 
	#
	#  test if option <ether> is selected and if the option's
	#  parameter correspond to the interface line's log
	#  else pass the log
	#  
	if ( $opt{ether} ) {
		if ( $opt{ether} eq "$ETHER" ) {
			$alert->{MON} = $MON;   $alert->{DAY} = $DAY;   $alert->{HOUR} = $HOUR;
			$alert->{MIN} = $MIN;   $alert->{SEC} = $SEC;   $alert->{SADDR} = $SADDR;
			$alert->{SPORT} = $SPORT;   $alert->{DADDR} = $DADDR;   $alert->{DPORT} = $DPORT;
			$alert->{HOST} = "localhost";
			$alert->{SIG} = "$SIG {$PROTO}";
			$alert->{TYPE} = "sys";
			$alert->{PLUGIN} = "none";
			$alert->{CLASS} = $CLASS;
			$alert->{PRIORITY} = $PRIORITY;
			$alert->{SEVERITY} = $SEVERITY;
			$alert->{ETHER} = $ETHER;
			$alert->{PROTO} = $PROTO;
			process_data($alert); $logids = 1;
			next;
		}
	} else {
		$alert->{MON} = $MON;   $alert->{DAY} = $DAY;   $alert->{HOUR} = $HOUR;
		$alert->{MIN} = $MIN;   $alert->{SEC} = $SEC;   $alert->{SADDR} = $SADDR;
		$alert->{SPORT} = $SPORT;   $alert->{DADDR} = $DADDR;   $alert->{DPORT} = $DPORT;
		$alert->{HOST} = "localhost";
		$alert->{SIG} = "$SIG {$PROTO}";
		$alert->{TYPE} = "sys";
		$alert->{PLUGIN} = "none";
		$alert->{CLASS} = $CLASS;
		$alert->{PRIORITY} = $PRIORITY;
		$alert->{SEVERITY} = $SEVERITY;
		$alert->{ETHER} = $ETHER;
		$alert->{PROTO} = $PROTO;
		process_data($alert);  $logids = 1;
		next;
	}


} elsif ( $_ =~ m/Len/o ) {
} elsif ( $_ =~ m/Xref/o ) {


#
#  test if the log correspond to a fast alert
#
} elsif ( $_ =~ /\d{2}\/\d{2}\-\d{2}\:\d{2}\:\d{2}\.\d+\s+\[\*\*\]/ ) {
#	$line = <>;
#	chomp($line);
	unless ( $_ eq "" ) {
		# strip off the [**] from either end.
		s/\s*\[\*\*\]\s*//og;
		s/\s*\[[0-9:]+\]\s*//o;
		if ( $_ =~ m/^(\d+)\/(\d+)\-(\d+)\:(\d+)\:(\d+)\.(\d+)(.*)/ox ) {
#		   ([\d\.]+)[\:]*([\d]*)\s[\-\>]+\s([\d\.]+)[\:]*([\d]*)\s(.+)/ox) {
			$alert->{MON} = $1;   $alert->{DAY} = $2;   $alert->{HOUR} = $3; 
			$alert->{MIN} = $4;   $alert->{SEC} = $5;   $alert->{SIG} = $7; 
			$alert->{HOST} = "localhost";
			search_date($1, $2, $3, $4, $5);
			$alert->{SIG} =~ s/\s*\[[\d\:]+\]\s*//;  # Get rid of [343:33:31]
			$alert->{SIG} =~ s/\[\*\*\]//og; # Get rid of [**] if fast alert
			#
			#  verify if there are an interface in the log line
			#  anf if it's the case, add interface in databse
			#  else pass the log
			#  
			$alert->{SIG} =~ s/\<([^\<|^\>]*?)\>//og;  # Get interface
			$alert->{ETHER} = $1;
			#
			#  test if option <ether> is selected and if the option's
			#  parameter correspond to the interface line's log
			#  
			if ( ( $opt{ether} ) && ( $opt{ether} ne "$1" ) ) {
				next;
			}

			if ($alert->{SIG} =~ m/^\(spp_portscan\d?\)\sPortscan\sdetected\sfrom\s([\d\.]+)/ox || m/spp_portscan:\s+End\sof\sportscan\sfrom\s([\d\.]+)/ox) { # portscan
				$alert->{SADDR} = $1; $alert->{TYPE} = "plugin";
				$alert->{PLUGIN} = "portscan"; $alert->{SEVERITY} = "unknown";
				process_data($alert); $lastwassnort = 1; $logids = 1; next;
			} elsif ( $alert->{SIG} =~ s/\s([\d\.]+)[\:]?([\d]*)\s[\-\>]+\s
                           ([\d\.]+)[\:]?([\d]*)\s*//x) {
				$alert->{SADDR} = $1; $alert->{SPORT} = $2; 
				$alert->{DADDR} = $3; $alert->{DPORT} = $4; 
				if ($alert->{SIG} =~ m/spp_anomsensor\:\sAnomaly\sthreshold\s
					  exceeded\:\s([\d\.]+)/ox) { # spade
					$alert->{THR} = $1; $alert->{TYPE} = "plugin"; 
					$alert->{PLUGIN} = "anomsensor"; $alert->{SEVERITY} = "unknown";
					process_data($alert); $lastwassnort = 1; $logids = 1; next;
				} elsif ($alert->{SIG} =~ s/spp_bo\:\s//ox) { # bo
					$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "bo"; $alert->{SEVERITY} = "unknown";
					process_data($alert); $lastwassnort = 1; $logids = 1; next;
				} elsif ($alert->{SIG} =~ /spp_stream4/) { # stream4 
					$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "stream4"; $alert->{SEVERITY} = "unknown";
					process_data($alert); $lastwassnort = 1; $logids = 1; next;
				} elsif ($alert->{SIG} =~ /spp_frag2/) { # frag2 
					$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "frag2"; $alert->{SEVERITY} = "unknown";
					process_data($alert); $lastwassnort = 1; $logids = 1; next;
				} elsif ($alert->{SIG} =~ /spp_portscan/ || /Spade/) { # Portsan && Spade
					$logids = 1; next;
				} elsif ($alert->{SIG} =~ /snort_decoder/) { # snort_decoder 
					$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "snort_decoder"; $alert->{SEVERITY} = "unknown";
					process_data($alert); $lastwassnort = 1; $logids = 1; next;
				} else { # normal alert
					if ( $alert->{SIG} =~ s/\[Classification\:([^\[|^\]]*?)\]\s*(?:\[Priority\:\s(\d)\])//x ) {
						if ($2 == 1) {
							$severity = "high";
						} elsif ($2 == 2) {
							$severity = "medium";
						} elsif ($2 == 3) {
							$severity = "low";
						} else {
							$severity = "unknown"
						}
						$alert->{CLASS} = $1; $alert->{PRIORITY} = $2; $alert->{SEVERITY} = $severity; 
					}
					if ( $alert->{SIG} =~ m/\{([^\{|^\}]*?)\}/o ) {
						$alert->{PROTO} = $1;
					}
					$alert->{TYPE} = "sys"; $alert->{PLUGIN} = "none";
					process_data($alert); $lastwassnort = 1; $logids = 1; next;
				}
    			}
		}
	} 


#
#  test if the log correspond to a syslog alert
#
} elsif ($_ =~ m/^(\w{3})\s+(\d+)\s(\d+)\:(\d+)\:(\d+)\s 
                   (\S+?)\ssnort[\[\d+\]]*\:\s+(.+)/ox 
      || m/^(\d+)\/(\d+)\-(\d+)\:(\d+)\:(\d+)\.(\d+)\s(.+)/ox) {
	$alert->{MON} = $1;    $alert->{DAY} = $2;    $alert->{HOUR} = $3; 
	$alert->{MIN} = $4;    $alert->{SEC} = $5;    $alert->{HOST} = $6;  
	search_date($monthday{$1}, $2, $3, $4, $5);
	$alert->{SIG} = $7;    
	$alert->{SIG} =~ s/\s*\[[\d\:]+\]\s*//;  # Get rid of [343:33:31]
	$alert->{SIG} =~ s/\[\*\*\]//og; # Get rid of [**] if fast alert

	if ($alert->{SIG} =~ m/^\(spp_portscan\d?\)\sPortscan\sdetected\sfrom\s([\d\.]+)/ox || m/spp_portscan:\sEnd\sof\sportscan\sfrom\s([\d\.]+)/ox) { # portscan
		$alert->{SADDR} = $1; $alert->{TYPE} = "plugin";
		$alert->{PLUGIN} = "portscan"; $alert->{SEVERITY} = "unknown";
		process_data($alert); $lastwassnort = 1; $logids = 1; next;
	} elsif ( $alert->{SIG} =~ s/\s([\d\.]+)[\:]?([\d]*)\s[\-\>]+\s
                           ([\d\.]+)[\:]?([\d]*)\s*//x) {
		$alert->{SADDR} = $1; $alert->{SPORT} = $2; 
		$alert->{DADDR} = $3; $alert->{DPORT} = $4; 
		if ($alert->{SIG} =~ m/spp_anomsensor\:\sAnomaly\sthreshold\s
			  exceeded\:\s([\d\.]+)/ox) { # spade
			$alert->{THR} = $1; $alert->{TYPE} = "plugin"; 
			$alert->{PLUGIN} = "anomsensor"; $alert->{SEVERITY} = "unknown";
			process_data($alert); $lastwassnort = 1; $logids = 1; next;
		} elsif ($alert->{SIG} =~ s/spp_bo\:\s//ox) { # bo
			$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "bo"; $alert->{SEVERITY} = "unknown";
			process_data($alert); $lastwassnort = 1; $logids = 1; next;
		} elsif ($alert->{SIG} =~ /spp_stream4/) { # stream4 
			$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "stream4"; $alert->{SEVERITY} = "unknown";
			process_data($alert); $lastwassnort = 1; $logids = 1; next;
		} elsif ($alert->{SIG} =~ /spp_frag2/) { # frag2 
			$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "frag2"; $alert->{SEVERITY} = "unknown";
			process_data($alert); $lastwassnort = 1; $logids = 1; next;
		} elsif ($alert->{SIG} =~ /spp_portscan/) { # frag2 
			$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "portscan"; $alert->{SEVERITY} = "unknown";
			process_data($alert); $lastwassnort = 1; $logids = 1; next;
		} elsif ($alert->{SIG} =~ /snort_decoder/) { # snort_decoder 
			$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "snort_decoder"; $alert->{SEVERITY} = "unknown";
			process_data($alert); $lastwassnort = 1; $logids = 1; next;
		} else { # normal alert
			if ( $alert->{SIG} =~ s/\[Classification\:([^\[|^\]]*?)\]\s*(?:\[Priority\:\s(\d)\]\:\s)//x ) {
				if ($2 == 1) {
					$severity = "high";
				} elsif ($2 == 2) {
					$severity = "medium";
				} elsif ($2 == 3) {
					$severity = "low";
				} else {
					$severity = "unknown"
				}
				$alert->{CLASS} = $1; $alert->{PRIORITY} = $2; $alert->{SEVERITY} = $severity;  
			}
			$alert->{TYPE} = "sys"; $alert->{PLUGIN} = "none";
			#
			#  verify if there are an interface in the log line
			#  anf if it's the case, add interface in databse
			#  
			if ( $alert->{SIG} =~ m/\</ ) {
				$alert->{SIG} =~ s/\<([^\<|^\>]*?)\>\s+//og;  # Get interface
				$alert->{ETHER} = $1;
				#
				#  test if option <ether> is selected and if the option's
				#  parameter correspond to the interface line's log
				#  else pass the log
				#  
				if ( ( $opt{ether} ) && ( $opt{ether} ne "$1" ) ) {
					next;
				}
			}
			$alert->{SIG} =~ m/\{([^\{|^\}]*?)\}/;  # Get interface
			$alert->{PROTO} = $1;
			process_data($alert); $lastwassnort = 1; $logids = 1; next;
		}
	}
# If a snort message has been repeated several times
} elsif ($lastwassnort && $_ =~ m/last message repeated (\d+) times/) {
# put the data in the matrix again for each repeat
	$repeats = $1;
	while ($repeats) {
		push @result, $result[-1];
		$repeats--;
	}
	next;
} else {
	$scrolled_debug->insert('end', "Log not recognize as snort's log -->\n$_\n\n") if ($opt_d == 1);
	++$logdrop; $lastwassnort = 0;
	next;
}				# Message not related to snort
}
$scrolled_status->insert('end', "OK\n") if ( ! $opt{file} );
work();
}



sub clear_screen {
	$scrolled_result->delete('1.0','end');
}


sub x_daily_event {
	get_opt();
	daily_event();
}

sub x_severity {
	get_opt();
	severity();
}

sub x_interfaces {
	get_opt();
	interfaces();
}

sub x_nids {
	get_opt();
	nids();
}

sub x_proto {
	get_opt();
	proto();
}

sub x_stateful {
	get_opt();
	stateful();
}

sub x_src_dst_attack {
	get_opt();
	same_src_dst_attack();
}

sub x_src_attack {
	get_opt();
	same_src_attack();
}

sub x_dst_attack {
	get_opt();
	same_dst_attack();
}

sub x_attack {
	get_opt();
	attack();
}

sub x_attack_src {
	get_opt();
	attack_src();
}

sub x_attack_dst {
	get_opt();
	attack_dst();
}

sub x_domain_src {
	get_opt();
	domain_src();
}

sub x_hour {
	get_opt();
	hour();
}

sub x_same_hour_attack {
	get_opt();
	same_hour_attack();
}

sub x_dport {
	get_opt();
	dport();
}

sub x_dport_attack {
	get_opt();
	dport_attack();
}


sub x_portscan {
	get_opt();
	portscan();
}


sub x_actions {
	get_opt();
	actions();
}


sub x_reasons {
	get_opt();
	reasons();
}


sub x_rules {
	get_opt();
	rules();
}


sub x_src_dport {
	get_opt();
	same_src_dport();
}


sub x_dst_dport {
	get_opt();
	same_dst_dport();
}




sub x_report {
	get_opt();
	print_head();
	print_summary();
	print_menu() if ($opt_h == 1);
	if ( $logids == 1 ) {
		proto();
		severity();
		hour();
		daily_event() if ($minmonth ne $maxmonth) || ($minday < $maxday);
		dport();
		nids() if (keys(%s13) > 1);
		interfaces() if (keys(%s1) > 1);
		domain_src() if ( $opt{c} );
		attack_src();
		same_src_attack();
		attack_dst();
		same_dst_attack();
		same_src_dst_attack();
		attack();
		same_class();
		same_hour_attack();
		dport_attack();
		stateful() if ($anomaly > 0);
		portscan() if ( $totalscan > 1 );
	}
	if ( $logfw == 1 ) {
		proto();
		hour();
		daily_event() if ($minmonth ne $maxmonth) || ($minday < $maxday);
		dport();
		nids() if (keys(%s13) > 1);
		interfaces() if (keys(%s1) > 1);
		domain_src() if ( $opt{c} );
		attack_src();
		attack_dst();
		same_src_dport();
		same_dst_dport();
		reasons() if ( keys(%s12) > 1 );
		actions() if ( keys(%s14) > 1 );
		rules() if ( keys(%s21) > 1 );
	}
	print_footer();
	$scrolled_status->insert('end', "HTML report generated :\t\t\tOK") if ( $opt_h == 1 );
}







sub load {	
$logtotal = 0;
$logdrop = 0;
$logfw = 0;
$logids = 0;
if ( $opt{genref} ) {
	open(RULES,">$opt{genref}") or die "Can not open domain file: $opt{genref} $!\n";
	while (<>) {
		next if ($_ eq "" or /^#/);
		if ( $_ =~ m/reference/ox ) {
			$_ =~ s/^alert\s(\w+)\s.+\s.+\>\s.+\s.+\(msg\:\"([^\"|^\"]*?)\".+reference\://x;
			$PROTO = $1; $PROTO =~ tr/a-z/A-Z/; $SIG = $2;
			$_ = ";$_";
			$_ =~ s/^\;([^\;|^\;]*?)\;.*$//x;
			$REF = $1;
			print RULES ("$SIG {$PROTO}\t\t$REF\n");
#			print ("$SIG {$PROTO}\t\t$REF\n");
		}
	}
	close (RULES);
} else {	
	# process whatever comes in
 
	while (<>) {
	my $alert = {};
	chomp;
	# if the line is blank, go to the next one
	next if $_ eq "";
	++$logtotal;



	# This is netscreen log 
	if ($_ =~ m/NetScreen/) {
	}


	# This is ipf log 
	if ($_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+(\S+)\s+ipmon\[\d+\]\:\s+\S+\s+(\S+)\s+\S+\s\S+\s+([\d\.]+)\,(\d+)\s+\-\>\s+([\d\.]+)\,(\d+)\s+\S+\s+(\S+)*// || s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+(\S+)\s+ipmon\[\d+\]\:\s+\S+\s+\S+\s(\S+)\s+\S+\s\S+\s+([\d\.]+)\,(\d+)\s+\-\>\s+([\d\.]+)\,(\d+)\s+\S+\s+(\S+)*//) {
		$alert->{MON} = $monthday{$1};    $alert->{DAY} = $2;    $alert->{HOUR} = $3; 
		$alert->{MIN} = $4;    $alert->{SEC} = $5;    $alert->{HOST} = $6;  
		$alert->{ETHER} = $7;    $alert->{SADDR} = $8;    $alert->{SPORT} = $9;  
		$alert->{DADDR} = $10;    $alert->{DPORT} = $11;    $alert->{PROTO} = $12;  $alert->{TYPE} = "alert";
		if ( ( $opt{ether} ) && ( $opt{ether} ne "$7" ) ) {
			next;
		}
		search_date($monthday{$1}, $2, $3, $4, $5);
		process_data($alert); $logfw = 1;
		#print "$1\t$2\t$3\t$4\t$5\t$6\t$7\t$8\t$9\t$10\t$11\t$12\n";
	} elsif ($_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+(\S+)\s+ipmon\[\d+\]\:\s+\S+\s+(\S+)\s+\S+\s\S+\s+([\d\.]+)\s+\-\>\s+([\d\.]+)\s+\S+\s+(\S+)*//) {
		$alert->{MON} = $monthday{$1};    $alert->{DAY} = $2;    $alert->{HOUR} = $3; 
		$alert->{MIN} = $4;    $alert->{SEC} = $5;    $alert->{HOST} = $6;  
		$alert->{ETHER} = $7;    $alert->{SADDR} = $8;  
		$alert->{DADDR} = $9;    $alert->{PROTO} = $10;  $alert->{TYPE} = "alert";
		if ( ( $opt{ether} ) && ( $opt{ether} ne "$7" ) ) {
			next;
		}
		search_date($monthday{$1}, $2, $3, $4, $5);
		process_data($alert); $logfw = 1;
 


	# This is fw1 4.1 log 
	} elsif ( $_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+\S+\s+\S+\s+\S+\s+(\S+)\s+(\S+)\s+[\>|\<](\S+)\s+proto\s+(\S+)\s+src\s+([\d\.]+)\s+dst\s+([\d\.]+)\s+//ox ) {
		$alert->{MON} = $monthday{$1};    $alert->{DAY} = $2;    $alert->{HOUR} = $3;
		$alert->{MIN} = $4;    $alert->{SEC} = $5;    $alert->{ACTION} = $6;    $alert->{HOST} = $7;
		$alert->{ETHER} = $8;    $alert->{SADDR} = $10;         $alert->{DADDR} = $11;  $alert->{PROTO} = $9;  $alert->{TYPE} = "alert";
		if ( ( $opt{ether} ) && ( $opt{ether} ne "$8" ) ) {
			next;
		}
		search_date($monthday{$1}, $2, $3, $4, $5);
		if ( $_ =~ s/^service\s+(\S+)\s+s_port\s+(\S+)\s+//ox ) {
        		$alert->{DPORT} = $1;    $alert->{SPORT} = $2;
		}
		if ( $_ =~ s/^rule\s+(\d+)\s+reason:\s+//ox) {
       	   		$alert->{REASON} = $_; $alert->{RULE} = $1;
       	 	} elsif ( $_ =~ s/^rule\s+(\d+)\s+//ox) {
        		$alert->{REASON} = $_; $alert->{RULE} = $1;
       	 	} elsif ($_ =~ s/^len\s+\d+\s+rule\s+(\d+)//ox) {
        		$alert->{REASON} = "normal connection dropped"; $alert->{RULE} = $1;
       		}
		process_data($alert); $logfw = 1;


	# This is fw1 NG log (DAEMON message ONLY)
	} elsif ( $_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+\S+\s+\S+\s+\[[^\[|^\]]*?\]\s+\d+\:\d+\:\d+\s+(\S+)\s+([\d\.]+)\s+[\>|\<](\S+)\s+sys_message\:[^\:|^\;]*?\;//ox ) {
		$alert->{MON} = $monthday{$1}; $alert->{DAY} = $2; $alert->{HOUR} = $3;
		$alert->{MIN} = $4; $alert->{SEC} = $5;	$alert->{ACTION} = $6; $alert->{HOST} = $7;
		$alert->{ETHER} = $8; $alert->{REASON} = $9; $alert->{RULE} = 0; $alert->{TYPE} = "alert";
		search_date($monthday{$1}, $2, $3, $4, $5);
		process_data($alert); $logfw = 1;



	# This is fw1 NG log (ICMP ONLY)
	} elsif ( $_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+\S+\s+\S+\s+\[[^\[|^\]]*?\]\s+\d+\:\d+\:\d+\s+(\S+)\s+([\d\.]+)\s+[\>|\<](\S+)\s+\w+\:[^\:|^\;]*?\;\s+src\:\s+([\d\.]+)\;\s+dst\:\s+([\d\.]+)\;\s+proto\:\s+(\w+)\;\s+icmp-type\:\s+\d+\;\s+icmp-code\:\s+\d+\;\s+//ox ) {
		$alert->{MON} = $monthday{$1}; $alert->{DAY} = $2; $alert->{HOUR} = $3;
		$alert->{MIN} = $4; $alert->{SEC} = $5;	$alert->{ACTION} = $6; $alert->{HOST} = $7;
		$alert->{ETHER} = $8; $alert->{SADDR} = $9; $alert->{DADDR} = $10; $alert->{PROTO} = $11;
		$alert->{TYPE} = "alert";
#		print "$1\t$2\t$3\t$4\t$5\t$6\t$7\t$8\t$9\t$10\t$11\t$12";
#		print "$_\n";
		search_date($monthday{$1}, $2, $3, $4, $5);
		if ( $_ =~ s/rule\:\s+(\d+)\;//ox ) {
       	   		$alert->{RULE} = $1;
		} else {
       	   		$alert->{RULE} = 0;
       		}
		if ( $_ =~ s/message_info\:\s+([^\:|^\;]*?)\;//ox) {
       	   		$alert->{REASON} = $1;
		} else {
			$alert->{REASON} = "normal connection dropped";
		}
		if ( ( $opt{ether} ) && ( $opt{ether} ne "$8" ) ) {
			next;
		}
		process_data($alert); $logfw = 1;


	# This is fw1 NG log (EXCEPT ICMP)
	} elsif ( $_ =~ s/^(\w{3})\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+\S+\s+\S+\s+\[[^\[|^\]]*?\]\s+\d+\:\d+\:\d+\s+(\S+)\s+([\d\.]+)\s+[\>|\<](\S+)\s+\w+\:[^\:|^\;]*?\;\s+src\:\s+([\d\.]+)\;\s+s_port\:\s+([\d|\w|\-|\d]+)\;\s+dst\:\s+([\d\.]+)\;\s+service\:\s+([\d|\w|\-|\d]+)\;\s+proto\:\s+(\w+)\;\s+//ox ) {
		$alert->{MON} = $monthday{$1}; $alert->{DAY} = $2; $alert->{HOUR} = $3;
		$alert->{MIN} = $4; $alert->{SEC} = $5;	$alert->{ACTION} = $6; $alert->{HOST} = $7;
		$alert->{ETHER} = $8; $alert->{SADDR} = $9; $alert->{SPORT} = $10; $alert->{DADDR} = $11;
		$alert->{DPORT} = $12; $alert->{PROTO} = $13; $alert->{RULE} = $13; $alert->{TYPE} = "alert";
		search_date($monthday{$1}, $2, $3, $4, $5);
		if ( $_ =~ s/rule\:\s+(\d+)\;//ox) {
       	   		$alert->{RULE} = $1;
		} else {
       	   		$alert->{RULE} = 0;
       		}
		if ( $_ =~ s/message_info\:\s+([^\:|^\;]*?)\;//ox) {
       	   		$alert->{REASON} = $1;
		} else {
			$alert->{REASON} = "normal connection dropped";
       		}
		if ( ( $opt{ether} ) && ( $opt{ether} ne "$8" ) ) {
			next;
		}
		process_data($alert); $logfw = 1;






	#
	#  test if the log correspond to the first line of snort's full alert
	#
	} elsif ( $_ =~ /^\[\*\*\]/ ) {
		if ( $_ =~ m/^\[\*\*\]\s+\[[0-9:]+\]\s\(spp_portscan\d\)\sPortscan\sdetected\sfrom\s([\d\.]+)/ox || m/^\[\*\*\]\s+\[[0-9:]+\]\sspp_portscan:\s+End\sof\sportscan\sfrom\s([\d\.]+)/ox) { # portscan
			$alert->{SADDR} = $1; $alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "portscan"; $alert->{SEVERITY} = "unknown";
			process_data($alert); next; $logids = 1;
#		} elsif ( $_ =~ m/^\[\*\*\]\s+\[[0-9:]+\]\sspp_portscan:\s+End\sof\sportscan\sfrom\s([\d\.]+)/ox) {
#			$alert->{SADDR} = $1; $alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "portscan"; $alert->{SEVERITY} = "unknown";
#			process_data($alert); next; $logids = 1;
		} elsif ( $_ =~ m/spp_portscan/ox || m/Spade/ox) {
			next; $logids = 1;
		} else {
			s/\s*\[\*\*\]\s*//og;
			s/\s*\[[0-9:]+\]\s*//o;
			#
			#  verify if there are an interface in the log line
			#  anf if it's the case, add interface in databse
			#  
			s/\<([^\<|^\>]*?)\>//og;  # Get interface
			$ETHER = $1;
			if ( ( $opt{ether} ) && ( $opt{ether} ne "$1" ) ) {
				next; next; next;
			}
			$SIG = $_;
			next;
		}


	#
	#  test if the log correspond to the second line of snort's full alert
	#
	} elsif ( $_ =~ m/^\[Classification\:([^\[|^\]]*?)\]\s+\[Priority\:\s+(\d{1})\]/ox ) {
		if ($2 == 1) {
			$severity = "high";
		} elsif ($2 == 2) {
			$severity = "medium";
		} elsif ($2 == 3) {
			$severity = "low";
		} else {
			$severity = "unknown"
		}
		$CLASS = $1;
		$PRIORITY = $2;
		$SEVERITY = $severity;
		print "$CLASS $SEVERITY\n";
		next;


	#
	#  test if the log correspond to the third line of snort's full alert
	#
	} elsif ( $_ =~ /^(\d{2})\/(\d{2})\-(\d{2})\:(\d{2})\:(\d{2})\.\d+\s+([\d\.]+)\:?([\d]*)\s[\-\>]+\s([\d\.]+)\:?([\d]*)/) {
		$MON = $1; $DAY = $2; $HOUR = $3; $MIN = $4; $SEC = $5; $SADDR = $6; $SPORT = $7; $DADDR = $8; $DPORT = $9;
		search_date($MON, $DAY, $HOUR, $MIN, $SEC);
		print "$SADDR $DADDR\n";
		next;
	



	#
	#  test if the log correspond to the fourth line of snort's full alert
	#
	} elsif ( $_ =~ m/^(\w+)\s.+ID:\d+\sIpLen\:\d+\sDgmLen\:\d+/ox ) {
		$PROTO = $1; 
		#
		#  test if option <ether> is selected and if the option's
		#  parameter correspond to the interface line's log
		#  else pass the log
		#  
		if ( $opt{ether} ) {
			if ( $opt{ether} eq "$ETHER" ) {
				$alert->{MON} = $MON;   $alert->{DAY} = $DAY;   $alert->{HOUR} = $HOUR;
				$alert->{MIN} = $MIN;   $alert->{SEC} = $SEC;   $alert->{SADDR} = $SADDR;
				$alert->{SPORT} = $SPORT;   $alert->{DADDR} = $DADDR;   $alert->{DPORT} = $DPORT;
				$alert->{HOST} = "localhost";
				$alert->{SIG} = "$SIG {$PROTO}";
				$alert->{TYPE} = "sys";
				$alert->{PLUGIN} = "none";
				$alert->{CLASS} = $CLASS;
				$alert->{PRIORITY} = $PRIORITY;
				$alert->{SEVERITY} = $SEVERITY;
				$alert->{ETHER} = $ETHER;
				$alert->{PROTO} = $PROTO;
				process_data($alert); $logids = 1;
				next;
			}
		} else {
			$alert->{MON} = $MON;   $alert->{DAY} = $DAY;   $alert->{HOUR} = $HOUR;
			$alert->{MIN} = $MIN;   $alert->{SEC} = $SEC;   $alert->{SADDR} = $SADDR;
			$alert->{SPORT} = $SPORT;   $alert->{DADDR} = $DADDR;   $alert->{DPORT} = $DPORT;
			$alert->{HOST} = "localhost";
			$alert->{SIG} = "$SIG {$PROTO}";
			$alert->{TYPE} = "sys";
			$alert->{PLUGIN} = "none";
			$alert->{CLASS} = $CLASS;
			$alert->{PRIORITY} = $PRIORITY;
			$alert->{SEVERITY} = $SEVERITY;
			$alert->{ETHER} = $ETHER;
			$alert->{PROTO} = $PROTO;
			process_data($alert); $logids = 1;
			print "$SADDR $DADDR\n";
			next;
		}
	} elsif ( $_ =~ m/Len/o ) {
	} elsif ( $_ =~ m/Xref/o ) {


	#
	#  test if the log correspond to a fast alert
	#
	} elsif ( $_ =~ /\d{2}\/\d{2}\-\d{2}\:\d{2}\:\d{2}\.\d+\s+\[\*\*\]/ ) {
	#	$line = <>;
	#	chomp($line);
		unless ( $_ eq "" ) {
			# strip off the [**] from either end.
			s/\s*\[\*\*\]\s*//og;
			s/\s*\[[0-9:]+\]\s*//o;
			if ( $_ =~ m/^(\d+)\/(\d+)\-(\d+)\:(\d+)\:(\d+)\.(\d+)(.*)/ox ) {
	#   ([\d\.]+)[\:]*([\d]*)\s[\-\>]+\s([\d\.]+)[\:]*([\d]*)\s(.+)/ox) {
				$alert->{MON} = $1;   $alert->{DAY} = $2;   $alert->{HOUR} = $3; 
				$alert->{MIN} = $4;   $alert->{SEC} = $5;   $alert->{SIG} = $7; 
				search_date($1, $2, $3, $4, $5);
				$alert->{HOST} = "localhost";
				$alert->{SIG} =~ s/\s*\[[\d\:]+\]\s*//;  # Get rid of [343:33:31]
				$alert->{SIG} =~ s/\[\*\*\]//og; # Get rid of [**] if fast alert
				#
				#  verify if there are an interface in the log line
				#  anf if it's the case, add interface in databse
				#  else pass the log
				#  
				$alert->{SIG} =~ s/\<([^\<|^\>]*?)\>//og;  # Get interface
				$alert->{ETHER} = $1;
				#
				#  test if option <ether> is selected and if the option's
				#  parameter correspond to the interface line's log
				#  
				if ( ( $opt{ether} ) && ( $opt{ether} ne "$1" ) ) {
					next;
				}
				if ($alert->{SIG} =~ m/^\(spp_portscan\d?\)\sPortscan\sdetected\sfrom\s([\d\.]+)/ox || m/spp_portscan:\s+End\sof\sportscan\sfrom\s([\d\.]+)/ox) { # portscan
					$alert->{SADDR} = $1; $alert->{TYPE} = "plugin";
					$alert->{PLUGIN} = "portscan"; $alert->{SEVERITY} = "unknown";
					process_data($alert); $lastwassnort = 1; $logids = 1; next;
				} elsif ( $alert->{SIG} =~ s/\s([\d\.]+)[\:]?([\d]*)\s[\-\>]+\s
       		                    ([\d\.]+)[\:]?([\d]*)\s*//x) {
					$alert->{SADDR} = $1; $alert->{SPORT} = $2; 
					$alert->{DADDR} = $3; $alert->{DPORT} = $4; 
					if ($alert->{SIG} =~ m/spp_anomsensor\:\sAnomaly\sthreshold\s
						  exceeded\:\s([\d\.]+)/ox) { # spade
						$alert->{THR} = $1; $alert->{TYPE} = "plugin"; 
						$alert->{PLUGIN} = "anomsensor"; $alert->{SEVERITY} = "unknown";
						process_data($alert); $lastwassnort = 1; $logids = 1; next;
					} elsif ($alert->{SIG} =~ s/spp_bo\:\s//ox) { # bo
						$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "bo"; $alert->{SEVERITY} = "unknown";
						process_data($alert); $lastwassnort = 1; $logids = 1; next;
					} elsif ($alert->{SIG} =~ /spp_stream4/) { # stream4 
						$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "stream4"; $alert->{SEVERITY} = "unknown";
						process_data($alert); $lastwassnort = 1; next;
					} elsif ($alert->{SIG} =~ /spp_frag2/) { # frag2 
						$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "frag2"; $alert->{SEVERITY} = "unknown";
						process_data($alert); $lastwassnort = 1; $logids = 1; next;
					} elsif ($alert->{SIG} =~ /spp_portscan/ || /Spade/) { # Portsan && Spade
						$logids = 1; next;
					} elsif ($alert->{SIG} =~ /snort_decoder/) { # snort_decoder 
						$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "snort_decoder"; $alert->{SEVERITY} = "unknown";
						process_data($alert); $lastwassnort = 1; $logids = 1; next;
					} else { # normal alert
						if ( $alert->{SIG} =~ s/\[Classification\:([^\[|^\]]*?)\]\s*(?:\[Priority\:\s(\d)\])//x ) {
							if ($2 == 1) {
								$severity = "high";
							} elsif ($2 == 2) {
								$severity = "medium";
							} elsif ($2 == 3) {
								$severity = "low";
							} else {
								$severity = "unknown"
							}
							$alert->{CLASS} = $1; $alert->{PRIORITY} = $2; $alert->{SEVERITY} = $severity; 
						}
						if ( $alert->{SIG} =~ m/\{([^\{|^\}]*?)\}/o ) {
							$alert->{PROTO} = $1;
						}
						$alert->{TYPE} = "sys"; $alert->{PLUGIN} = "none";
						process_data($alert); $lastwassnort = 1; $logids = 1; next;
					}
    				}
			}
		} 


	#
	#  test if the log correspond to a syslog alert
	#
	} elsif ($_ =~ m/^(\w{3})\s+(\d+)\s(\d+)\:(\d+)\:(\d+)\s 
			(\S+?)\ssnort[\[\d+\]]*\:\s+(.+)/ox 
			|| m/^(\d+)\/(\d+)\-(\d+)\:(\d+)\:(\d+)\.(\d+)\s(.+)/ox) {
		$alert->{MON} = $monthday{$1};    $alert->{DAY} = $2;    $alert->{HOUR} = $3; 
		$alert->{MIN} = $4;    $alert->{SEC} = $5;    $alert->{HOST} = $6;  
		$alert->{SIG} = $7;
		search_date($monthday{$1}, $2, $3, $4, $5);
		$alert->{SIG} =~ s/\s*\[[\d\:]+\]\s*//;  # Get rid of [343:33:31]
		$alert->{SIG} =~ s/\[\*\*\]//og; # Get rid of [**] if fast alert
	
		if ($alert->{SIG} =~ m/^\(spp_portscan\d?\)\sPortscan\sdetected\sfrom\s([\d\.]+)/ox || m/spp_portscan:\sEnd\sof\sportscan\sfrom\s([\d\.]+)/ox) { # portscan
			$alert->{SADDR} = $1; $alert->{TYPE} = "plugin";
			$alert->{PLUGIN} = "portscan"; $alert->{SEVERITY} = "unknown";
			process_data($alert); $lastwassnort = 1; $logids = 1; next;
		} elsif ( $alert->{SIG} =~ s/\s([\d\.]+)[\:]?([\d]*)\s[\-\>]+\s
       	                    ([\d\.]+)[\:]?([\d]*)\s*//x) {
			$alert->{SADDR} = $1; $alert->{SPORT} = $2; 
			$alert->{DADDR} = $3; $alert->{DPORT} = $4; 
			if ($alert->{SIG} =~ m/spp_anomsensor\:\sAnomaly\sthreshold\s
				  exceeded\:\s([\d\.]+)/ox) { # spade
				$alert->{THR} = $1; $alert->{TYPE} = "plugin"; 
				$alert->{PLUGIN} = "anomsensor"; $alert->{SEVERITY} = "unknown";
				process_data($alert); $lastwassnort = 1; $logids = 1; next;
			} elsif ($alert->{SIG} =~ s/spp_bo\:\s//ox) { # bo
				$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "bo"; $alert->{SEVERITY} = "unknown";
				process_data($alert); $lastwassnort = 1; $logids = 1; next;
			} elsif ($alert->{SIG} =~ /spp_stream4/) { # stream4 
				$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "stream4"; $alert->{SEVERITY} = "unknown";
				process_data($alert); $lastwassnort = 1; $logids = 1; next;
			} elsif ($alert->{SIG} =~ /spp_frag2/) { # frag2 
				$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "frag2"; $alert->{SEVERITY} = "unknown";
				process_data($alert); $lastwassnort = 1; $logids = 1; next;
			} elsif ($alert->{SIG} =~ /spp_portscan/ || /Spade/ ) { # Portsan && Spade
				$logids = 1; next;
			} elsif ($alert->{SIG} =~ /snort_decoder/) { # snort_decoder 
				$alert->{TYPE} = "plugin"; $alert->{PLUGIN} = "snort_decoder"; $alert->{SEVERITY} = "unknown";
				process_data($alert); $lastwassnort = 1; $logids = 1; next;
			} else { # normal alert
				if ( $alert->{SIG} =~ s/\[Classification\:([^\[|^\]]*?)\]\s*(?:\[Priority\:\s(\d)\]\:\s)//x ) {
					if ($2 == 1) {
						$severity = "high";
					} elsif ($2 == 2) {
						$severity = "medium";
					} elsif ($2 == 3) {
						$severity = "low";
					} else {
						$severity = "unknown"
					}
					$alert->{CLASS} = $1; $alert->{PRIORITY} = $2; $alert->{SEVERITY} = $severity;  
				}
				$alert->{TYPE} = "sys"; $alert->{PLUGIN} = "none";
				#
				#  verify if there are an interface in the log line
				#  anf if it's the case, add interface in databse
				#  
				if ( $alert->{SIG} =~ m/\</ ) {
					$alert->{SIG} =~ s/\<([^\<|^\>]*?)\>\s+//og;  # Get interface
					$alert->{ETHER} = $1;
					#
					#  test if option <ether> is selected and if the option's
					#  parameter correspond to the interface line's log
					#  else pass the log
					#  
					if ( ( $opt{ether} ) && ( $opt{ether} ne "$1" ) ) {
						next;
					}
				}
				$alert->{SIG} =~ m/\{([^\{|^\}]*?)\}/;  # Get interface
				$alert->{PROTO} = $1;
				process_data($alert); $lastwassnort = 1; $logids = 1; next;
			}
		}
	# If a snort message has been repeated several times
	} elsif ($lastwassnort && $_ =~ m/last message repeated (\d+) times/) {
	# put the data in the matrix again for each repeat
		$repeats = $1;
		while ($repeats) {
			push @result, $result[-1];
			$repeats--;
		}
		next;
	} else {
		print STDERR "Log not recognize as snort's log --> $_\n" if $opt{d}; 
		++$logdrop; $lastwassnort = 0;
		next;
	}				# Message not related to snort
}
work();
}


sub work {
# begin statistics
# I should've used $#result + 1 as $total in the first version! :(
$total = $#result + 1;
$totalscan = $#portscan + 1;

if ( $total == 0 ) {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "No Snort's logs found\n");
	} else {
		print "No Snort's logs found\n";
		exit;
	}
} else {
for $i ( 0 .. $#result ) {
  # for the same pair of attacker and victim with same attack
  # used in same_src_dst_attack()
  $s0{"$result[$i]->[9],$result[$i]->[7],$result[$i]->[6]"}++;
  # used in same_src_dst_attack()
  $s1{"$result[$i]->[15]"}++;
  # used in same_src_attack()
  $s2{"$result[$i]->[6],$result[$i]->[7],$result[$i]->[14]"}++;
  # to same victim with same method
  # to see how many attacks received by one host
  # used in same_dest_attack()
  $s3{"$result[$i]->[6],$result[$i]->[9],$result[$i]->[14]"}++;
  # same signature
  # to see the popularity of one attack method
  # used in attack()
  $s4{"$result[$i]->[6],$result[$i]->[13],$result[$i]->[14]"}++;
  # used in attack_src()
  $s5{"$result[$i]->[7]"}++;
  # used by attack_dst 
  $s6{"$result[$i]->[9]"}++;
  # used by hour()
  $s7{"$result[$i]->[2]"}++;
  # used by hour()
  $s8{"$result[$i]->[2],$result[$i]->[14]"}++;
  # use by same_hour_attack()
  $s9{"$result[$i]->[2],$result[$i]->[6]"}++;
  # to see classification
  # used by same_class() 
  $s10{"$result[$i]->[11],$result[$i]->[14]"}++;
  # use by proto()
  $s11{"$result[$i]->[16]"}++;
  # used by reasons()
  $s12{"$result[$i]->[18]"}++;
  # use by nids()
  $s13{"$result[$i]->[5]"}++;
    # use by action()
  $s14{"$result[$i]->[17]"}++;
  # use by daily_event()
  $s15{"$result[$i]->[1],$result[$i]->[0],$result[$i]->[14]"}++;
  # use by dport()
  $s16{"$result[$i]->[10]"}++;
  # use by stateful()
  $s17{"$result[$i]->[12]"}++;
  # use by dport_attack()
  $s18{"$result[$i]->[10],$result[$i]->[6]"}++;
  # use by daily_event()
  $s19{"$result[$i]->[1],$result[$i]->[0]"}++;
  # use by severity()
  $s20{"$result[$i]->[14]"}++;
  # used by rules()
  $s21{"$result[$i]->[19]"}++;
  # used by same_src_dport()
  $s22{"$result[$i]->[7],$result[$i]->[10]"}++;
  # used by same_dst_dport()
  $s23{"$result[$i]->[9],$result[$i]->[10]"}++;
}
$processor = keys(%s17);
$anomaly = --$processor;
init_domains() if $DOMAINS == 1;
init_rules() if $RULES == 1;
}
}
}

# print the header (e.g. for mail)
sub print_head {
if ( $logfw == 1 ) {
	$logger = "Firewall";
}
if ( $logids == 1 ) {
	$logger = "Ids";
}
if ( $opt_h == 1 ) {
	open (FILEOUT, ">$val_opt_u$val_opt_h") or die "Can no access file : $val_opt_u$val_opt_h\n";
	print FILEOUT ("<HTML>\n<HEAD>\n<TITLE>$logger statistics</TITLE>\n</HEAD>\n<STYLE>\n<!--\n");
#	print FILEOUT ("BODY { font-family: serif; background-color: #FFEFC6; font-size: 12px; }\n");
	print FILEOUT ("BODY { font-family: serif; background-color: #CCCCCC; font-size: 12px; }\n");
	print FILEOUT ("/* Table Header */\n");
	print FILEOUT (".TH { font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 12px; background-color: #FFCC99; color: blue; font-weight: bold; }\n");
	print FILEOUT ("/* Table body */\n");
	print FILEOUT (".TB { color: black; background-color: white; font-size: 12px; }\n");
	print FILEOUT ("/* Table body RED*/\n");
	print FILEOUT (".TBR { color: red; background-color: white; font-size: 12px; }\n");
	print FILEOUT ("/* Table body GREEN*/\n");
	print FILEOUT (".TBG { color: green; background-color: white; font-size: 12px; }\n");
	print FILEOUT ("-->\n</STYLE>\n</HEAD>\n");
	print FILEOUT ("<BODY>\n");
	print FILEOUT ("<H1><U>$logger statistics generated the $date</U></H1>\n");
#	close (FILEOUT);
} else {
	if ( !$opt{x} ) {			### IF GUI X
		print "subject: $logger report generated the $date\n"; 
	}
}
}

# print the time of begin and end of the log
sub print_summary {
	if ( $opt_h == 1 ) {
#		print FILEOUT ("<TABLE BORDER=1 ALIGN=CENTER BGCOLOR=#FFEFC6><TR><TD><TABLE BORDER=0><TR><TD WIDTH=65%>");
		print FILEOUT ("<TABLE BORDER=1 ALIGN=CENTER BGCOLOR=#FFCC99><TR><TD><TABLE BORDER=0><TR><TD WIDTH=65%>");
		print FILEOUT ("<TABLE VALIGN=top>\n");
		print FILEOUT ("<TR ALIGN=left><TH>The log begins at :</TH>");
		print FILEOUT ("<TD>$daymonth{$minmonth} $minday $minhour\:$minmin\:$minsec</TD></TR>\n");
		print FILEOUT ("<TR ALIGN=left><TH>The log ends at :</TH>");
		print FILEOUT ("<TD>$daymonth{$maxmonth} $maxday $maxhour\:$maxmin\:$maxsec</TD></TR>\n");
		print FILEOUT ("<TR><TD></TD></TR>\n");
		print FILEOUT ("<TR ALIGN=left><TH>Total of Lines in log file :</TH>");
		print FILEOUT ("<TD>$logtotal</TD></TR>\n");
		print FILEOUT ("<TR ALIGN=left><TH>Total of Logs Dropped :</TH>");
		printf FILEOUT ("<TD>%d (%2.2f%)</TD></TR>\n",$logdrop,$logdrop/$logtotal*100);
		print FILEOUT ("<TR><TD></TD></TR>\n");
		print FILEOUT ("<TR ALIGN=left><TH>Total events in table :</TH>");
		print FILEOUT ("<TD>$total</TD></TR>\n");
		print FILEOUT ("<TR ALIGN=left><TH>Source IP recorded :</TH>");
		print FILEOUT ("<TD>". keys(%s5) ."</TD></TR>\n");
		print FILEOUT ("<TR ALIGN=left><TH>Destination IP recorded :</TH>");
		print FILEOUT ("<TD>". keys(%s6) ."</TD></TR>\n");
		print FILEOUT ("<TR><TD></TD></TR>\n");
		if ( $logids == 1 ) {
			print FILEOUT ("<TR ALIGN=left><TH>NIDS recorded :</TH>");
			print FILEOUT ("<TD>". keys(%s13) ." with ". keys(%s1) . " interface(s)</TD></TR>\n");
			print FILEOUT ("<TR ALIGN=left><TH>Signatures recorded :</TH>");
			print FILEOUT ("<TD>". keys(%s4) ."<TD></TR>\n");
			print FILEOUT ("<TR ALIGN=left><TH>Classification recorded :</TH>");
			print FILEOUT ("<TD>". keys(%s10) ."</TD></TR>\n");
			print FILEOUT ("<TR ALIGN=left><TH>Severity recorded :</TH>");
			print FILEOUT ("<TD>". keys(%s20) ."</TD></TR>\n");
			print FILEOUT ("<TR ALIGN=left><TH>Preprocessor anomaly :</TH>");
			print FILEOUT ("<TD>". $anomaly ."</TD></TR>\n");
			print FILEOUT ("<TR ALIGN=left><TH>Portscan detected :</TH>") if $totalscan > 1;
			print FILEOUT ("<TD>". $totalscan ."</TD></TR>\n") if $totalscan > 1;
		}
		if ( $logfw == 1 ) {
			print FILEOUT ("<TR ALIGN=left><TH>Firewall recorded :</TH>");
			print FILEOUT ("<TD>". keys(%s13) ." with ". keys(%s1) . " interface(s)</TD></TR>\n");
		}
		print FILEOUT ("</TABLE>\n");
		
		print FILEOUT ("</TD><TD VALIGN=top>\n");
	
		print FILEOUT ("<TABLE>\n");
		print FILEOUT ("<TR ALIGN=left><B>Domains File : </B>$domains_file</TR><BR>\n");
		print FILEOUT ("<TR ALIGN=left><B>Number of domains : </B>". keys(%DomainName) ."</TR><BR><BR>\n");
		print FILEOUT ("<TR ALIGN=left><B>Rules File : </B>$rules_file</TR><BR>\n");
		print FILEOUT ("<TR ALIGN=left><B>Number of referenced rules : </B>". keys(%link) ."</TR><BR>\n");
		print FILEOUT ("</TABLE></TABLE><BR>\n");

		print FILEOUT ("<TABLE BORDER=0 WIDTH=100%>\n");
		print FILEOUT ("<TR ALIGN=left><TD WIDTH=15%><B><U>Legende :</U></B></TD><TD WIDTH=10%></TD><TD></TD></TR>\n");
		print FILEOUT ("<TR ALIGN=left><TD WIDTH=15%></TD><TD WIDTH=10%><FONT COLOR=RED>RED :</FONT></TD><TD>$legende_red</TD></TR>\n");
		print FILEOUT ("<TR ALIGN=left><TD WIDTH=15%></TD><TD WIDTH=10%><FONT COLOR=GREEN>GREEN :</FONT></TD><TD>$legende_green</TD></TR>\n");
		print FILEOUT ("<TR ALIGN=left><TD WIDTH=15%></TD><TD WIDTH=10%>BLACK :</TD><TD>$legende_black</TD></TR>\n");
		print FILEOUT ("</TABLE><BR>\n");
	} else {
		if ( $opt{x} ) {			### IF GUI X
			$scrolled_status->insert('end', "Printing Summary :\t\t\t");
			$scrolled_result->insert ('end', "The log begins from: $daymonth{$minmonth} $minday $minhour\:$minmin\:$minsec\n");
			$scrolled_result->insert ('end', "The log ends at: $daymonth{$maxmonth} $maxday $maxhour\:$maxmin\:$maxsec\n");
			$scrolled_result->insert ('end', "\n");
			$scrolled_result->insert ('end', "Total of Lines in log file: $logtotal\n");
			$scrolled_result->insert ('end', "Total of Logs Dropped: ". $logdrop ." (". $logdrop/$logtotal*100 ."%)\n");
			$scrolled_result->insert ('end', "\n");
			$scrolled_result->insert ('end', "Total events in table: $total\n");
			$scrolled_result->insert ('end', "Source IP recorded: ". keys(%s5) ."\n");
			$scrolled_result->insert ('end', "Destination IP recorded: ". keys(%s6) ."\n");
			$scrolled_result->insert ('end', "\n");
			if ( $logids == 1 ) {
				$scrolled_result->insert ('end', "NIDS recorded: ". keys(%s13) ." with ". keys(%s1) ." interface(s)\n");
				$scrolled_result->insert ('end', "Signatures recorded: ". keys(%s4) ."\n");
				$scrolled_result->insert ('end', "Classification recorded: ". keys(%s10) ."\n");
				$scrolled_result->insert ('end', "Preprocessor anomaly: ". $anomaly ."\n");
				$scrolled_result->insert ('end', "Severity recorded: ". keys(%s20) ."\n");
				$scrolled_result->insert ('end', "Portscan recorded: ". keys(%s41) ."\n") if ( $totalscan > 1 );
				$scrolled_result->insert ('end', "\n");
				$scrolled_status->insert ('end', "OK\n");
			}
			if ( $logfw == 1 ) {
				$scrolled_result->insert ('end', "Firewall recorded: ". keys(%s13) ." with ". keys(%s1) ." interface(s)\n");
				$scrolled_result->insert ('end', "\n");
			}
			$scrolled_status->insert('end', "OK\n");
		} else {
			chomp $minmonth;
			chomp $maxmonth;
			print "The logs begins from: $daymonth{$minmonth} $minday $minhour\:$minmin\:$minsec\n";
			print "The log ends at: $daymonth{$maxmonth} $maxday $maxhour\:$maxmin\:$maxsec\n";
			print "\n";
			print "Total of Lines in log file: $logtotal\n";
			printf ("Total of Logs Dropped: %d (%5.2f%)\n",$logdrop,$logdrop/$logtotal*100);
			print "\n";
			print "Total events in table: $total\n";
			print "Source IP recorded: ". keys(%s5) ."\n";
			print "Destination IP recorded: ". keys(%s6) ."\n";
			print "\n";
			if ( $logids == 1 ) {
				print "NIDS recorded: ". keys(%s13) ." with ". keys(%s1) ." interface(s)\n";
				print "Signatures recorded: ". keys(%s4) ."\n";
				print "Classification recorded: ". keys(%s10) ."\n";
				print "Severity recorded: ". keys(%s20) ."\n";
				print "Preprocessor anomaly: ". $anomaly ."\n";
				print "Portscan recorded: ". keys(%s41) ."\n" if ( $totalscan > 1 );;
			}
			if ( $logfw == 1 ) {
				print "Firewall recorded: ". keys(%s13) ." with ". keys(%s1) ." interface(s)\n";
			}
		}
	}
}


# print menu for HTML page
sub print_menu {
	if ( $opt_h == 1) {
		print FILEOUT ("<TABLE BORDER=0 ALIGN=CENTER><TR ALIGN=left><TD WIDTH=50% VALIGN=top>\n");
		print FILEOUT ("<U><B>General Statistics</B></U><P>\n");
		print FILEOUT ("<li><a href=\"#hour\">The distribution of event by hour</a>\n");
		print FILEOUT ("<li><a href=\"#daily_event\">The distribution of event by day</a>\n") if ($minmonth ne $maxmonth) || ($minday < $maxday);
		print FILEOUT ("<li><a href=\"#nids\">The distribution of event by $logger</a>\n") if (keys(%s13) > 1);
		print FILEOUT ("<li><a href=\"#domain_src\">To see the popularity of one domain</a>\n") if ( $opt{c} );
		print FILEOUT ("<li><a href=\"#attack_src\">Popularity of one source host</a>\n");
		print FILEOUT ("<li><a href=\"#attack_dst\">Popularity of one destination host</a>\n");
		print FILEOUT ("<li><a href=\"#dport\">The distribution of event by destination port</a>\n");
		print FILEOUT ("<li><a href=\"#proto\">The distribution of event by protocoles</a>\n");
		print FILEOUT ("<li><a href=\"#interfaces\">The distribution of event by interfaces</a>\n") if (keys(%s1) > 1);
	
		print FILEOUT ("</TD><TD WIDTH=50% VALIGN=top>\n");
		
		print FILEOUT ("<U><B>Specific Statistics for $logger</B></U><P>\n");
		if ( $logfw == 1 ) {	
			print FILEOUT ("<li><a href=\"#same_src_dport\">Popularity of one source host by destination port</a>\n");
			print FILEOUT ("<li><a href=\"#same_dst_dport\">Popularity of one destination host by destination port</a>\n");
			print FILEOUT ("<li><a href=\"#actions\">Popularity of one action</a>\n");
			print FILEOUT ("<li><a href=\"#reasons\">Popularity of one reason</a>\n");
			print FILEOUT ("<li><a href=\"#rules\">Popularity of one rule</a>\n");
		} 
		if ( $logids == 1 ) {	
			print FILEOUT ("<li><a href=\"#same_src_attack\">Events from one host to any with same method</a>\n");
			print FILEOUT ("<li><a href=\"#same_dst_attack\">Events to one host from any with same method</a>\n");
			print FILEOUT ("<li><a href=\"#same_src_dst_attack\">Events from a host to a destination</a>\n");
			print FILEOUT ("<li><a href=\"#port_attack\">Events to one destination port grouped by attack</a>\n");
			print FILEOUT ("<li><a href=\"#attack\">Distribution of attack methods</a>\n");
			print FILEOUT ("<li><a href=\"#same_class\">Distribution of classification method</a>\n");
			print FILEOUT ("<li><a href=\"#severity\">The distribution of event by severity</a>\n");
			print FILEOUT ("<li><a href=\"#stateful\">Distribution of stateful problems</a>\n") if ($anomaly > 0);
			print FILEOUT ("<li><a href=\"#hour_attack\">Events by hour</a>\n");
			print FILEOUT ("<li><a href=\"#portscan\">Portscan list</a>\n") if ( $totalscan > 1 );
		}
		print FILEOUT ("</ul>\n");
		print FILEOUT ("</TD></TR></TABLE></TD></TR></TABLE><BR>\n");
	}
}       







sub daily_event {
$max = 0;
if ( $opt_h == 1 ) {
	@list1 = ();
	@list2 = ();
	print FILEOUT ("<h3><CENTER><a name=\"daily_event\" HREF=\"#top\">The distribution of event by day</a></h3>\n");
	print FILEOUT ("<table border=1 align=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>Jour</td><td>Mois</td><td>Nb</td><td>%</td><td>Graph</td></tr>");

	foreach $k (%s19) {
		$max = $s19{$k} if ($s19{$k} > $max);
	}
	my $ratio = $max/$total*100;
	foreach $k (sort { $a <=> $b } keys %s19) {
		@_ = split ",",$k;
		my $num = $s19{$k}/$total*(50000/$ratio);
		printf FILEOUT ("<TR CLASS=TB><TD>%-${hour_len}d</TD><TD>%-3s</TD><TD>%-${nb_len}d</TD><TD>%-2.2f</TD><TD WIDTH=$num><HR NOSHADE ALIGN=LEFT SIZE=10 COLOR=#CCCCCC WIDTH=%3d ></TD></TR>\n",$_[0],$_[1],$s19{$k},$s19{$k}/$total*100,$num);
		push @list1 ,($s19{$k});
		push @list2 ,("$_[0]");
	}
 	if ( $opt_g == 1 ) {
		init_graph("days1","area") if ($opt_g == 1);
		print FILEOUT ("<TABLE BORDER=0 ALIGN=center><TR><TD><IMG SRC=".$graph_name._days1.".".$val_opt_g."></TD></TR></TABLE><BR>\n");
	} else {
		print FILEOUT ("</TD></TR></TABLE><BR>\n");
	}

	if (( $logids == 1 ) and ( $opt_g == 1 )) {
		$compt = 1;	
		foreach $k (sort { $a <=> $b } keys %s15) {
			@_ = split ",",$k;
			$beforeday = $_[0];
			$belowday = $beforeday if ( $compt == 1 );
			if ( $belowday < $beforeday ) {
				if ( $low ) {
					push @listlow ,($low);
					undef $low;
				} else {
					push @listlow ,(0);
				}
				if ( $medium ) {
					push @listmedium ,($medium);
					undef $medium;
				} else {
					push @listmedium ,(0);
				}
				if ( $high ) {
					push @listhigh ,($high);
					undef $high;
				} else {
					push @listhigh ,(0);
				}
				if ( $unknown ) {
					push @listunknown ,($unknown);
					undef $unknown;
				} else {
					push @listunknown ,(0);
				}
			}
			if ( $_[2] eq "low") {
				$low = $s15{$k};
			} elsif ( $_[2] eq "medium" ) {
				$medium = $s15{$k};
			} elsif ( $_[2] eq "high" ) {
				$high = $s15{$k};
			} elsif ( $_[2] eq "unknown" ) {
				$unknown = $s15{$k};
			}
			$belowday = $beforeday;
			$compt ++;
		}
		if ( $low ) {
			push @listlow ,($low);
			undef $low;
		} else {
			push @listlow ,(0);
		}
		if ( $medium ) {
			push @listmedium ,($medium);
			undef $medium;
		} else {
			push @listmedium ,(0);
		}
		if ( $high ) {
			push @listhigh ,($high);
		} else {
			push @listhigh ,(0);
		}
		if ( $unknown ) {
			push @listunknown ,($unknown);
			undef $unknown;
		} else {
			push @listunknown ,(0);
		}
		init_graph("days2","lines");
		print FILEOUT ("<TABLE BORDER=0 ALIGN=center><TR><TD><IMG SRC=".$graph_name._days2.".".$val_opt_g."></TD></TR></TABLE><BR>\n");
	}
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "daily_event() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		$linelength = 20 + $nb_len + 6 + $graph_len;
		print FILEOUT ("The distribution of event by day\n");
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". keys(%s19) ." of ". keys(%s19) ." ###\n");
		print FILEOUT (" Day Month  nb         %    Graph\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (%s19) {
			$max = $s19{$k} if ($s19{$k} > $max);
		}
		$ratio = $max/$total*100;
		foreach $k (sort { $a <=> $b } keys %s19) {
			@_ = split ",",$k;
			$num = $s19{$k}/$total*75*(100 / $ratio);
			printf FILEOUT ("  %-${hour_len}d   %-3s   %-${nb_len}d  %5.2f  %-${graph_len}s\n", $_[0],$_[1],$s19{$k},$s19{$k}/$total*100, '#' x $num);
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");

	} else {
		foreach $k (%s19) {
			$max = $s19{$k} if ($s19{$k} > $max);
		}
		$ratio = $max/$total*100;
		section_header("The distribution of event by day\n", "daily_event");
		foreach $k (sort { $a <=> $b } keys %s19) {
			@_ = split ",",$k;
			$num = $s19{$k}/$total*75*(100 / $ratio);
			printf("  %-${hour_len}d   %-3s   %-${nb_len}d  %5.2f  %-${graph_len}s\n", $_[0],$_[1],$s19{$k},$s19{$k}/$total*100, '#' x $num);
		}
	}
}
}


sub severity {
$max = 0;
if ( $opt_h == 1 ) {
	@list1 = ();
	@list2 = ();
	print FILEOUT ("<H3><CENTER><A NAME=\"severity\" HREF=\"#top\">The distribution of severity</A></CENTER></H3>\n");
	print FILEOUT ("<TABLE BORDER=0 ALIGN=center><TR><TD><TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<TR CLASS=TH ALIGN=center><TD>%</TD><TD>Nb</TD><TD>Severity</TD></TR>");
	foreach $k (sort { $s20{$b} <=> $s20{$a} } keys %s20) {
		$STYLE = init_color($k);
		printf FILEOUT (("<tr class=$STYLE><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${sever_len}s</td></tr>\n", $s20{$k}/$total*100,$s20{$k},$k));
		push @list1 ,($s20{$k}/$total*100);
		push @list2 ,("$k");
	}
	if ( $opt_g == 1 ) {
		init_graph("severity","pie");
		print FILEOUT ("</TABLE></TD><TD WIDTH=300 ALIGN=right><IMG SRC=".$graph_name._severity.".".$val_opt_g."></TD></TR></TABLE><BR>\n");
	} else {
		print FILEOUT ("</TABLE></TD></TR></TABLE><BR>\n");
	}
} else {
	foreach $k (%s20) {
		$max = $s20{$k} if ($s20{$k} > $max);
	}
	$ratio = $max/$total*100;
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "severity() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "The distribution of severity\n";
		$linelength = 13 + $nb_len + 2 + $sever_len + 2 + $graph_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". keys(%s20) ." of ". keys(%s20) ." ###\n");
		print FILEOUT ("    %    nb      Severity Graph\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort { $s20{$b} <=> $s20{$a} } keys %s20) {
			$num = $s20{$k}/$total*75*(100 / $ratio);
			printf FILEOUT ("  %-5.2f  %-${nb_len}d  %-${sever_len}s  %-${graph_len}s\n", $s20{$k}/$total*100,$s20{$k},$k, '#' x $num);
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {
		section_header("The distribution of severity\n", "severity");
		foreach $k (sort { $s20{$b} <=> $s20{$a} } keys %s20) {
			$num = $s20{$k}/$total*75*(100 / $ratio);
			printf("  %-5.2f  %-${nb_len}d  %-${sever_len}s  %-${graph_len}s\n", $s20{$k}/$total*100,$s20{$k},$k, '#' x $num);
		}

	}
}
}



sub interfaces {
if ($opt_h == 1) {
	@list1 = ();
	@list2 = ();
	print FILEOUT ("<H3><CENTER><A NAME=\"interfaces\" HREF=\"#top\">The distribution of event by interfaces</A></CENTER></H3>\n");
	print FILEOUT ("<TABLE BORDER=0 ALIGN=center><TR><TD><TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<TR CLASS=TH ALIGN=center><TD>%</TD><TD>Nb</TD><TD>Interface</TD></TR>");
	foreach $k (sort { $s1{$b} <=> $s1{$a} } keys %s1) {
		printf FILEOUT (("<TR CLASS=TB><TD>%2.2f</TD><TD>%-${nb_len}d</TD><TD>%-32s</TD></TR>\n", $s1{$k}/$total*100,$s1{$k},$k));
		push @list1 ,($s1{$k}/$total*100);
		push @list2 ,("$k");
	}
	if ( $opt_g == 1 ) {
		init_graph("ether","pie");
		print FILEOUT ("</TABLE></TD><TD WIDTH=300 ALIGN=right><IMG SRC=".$graph_name._ether.".".$val_opt_g."></TD></TR></TABLE><BR>\n");
	} else {
		print FILEOUT ("</TABLE></TD></TR></TABLE><BR>\n");
	}
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "interfaces() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "The distribution of event by interfaces\n";
		$linelength = 50;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". keys(%s1) ." of ". keys(%s1) ." ###\n");
		print FILEOUT ("    %    nb      Interfaces\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort { $s1{$b} <=> $s1{$a} } keys %s1) {
			printf FILEOUT ("  %5.2f  %-${nb_len}d  %-10s\n", $s1{$k}/$total*100,$s1{$k},$k); 
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("The distribution of event by interfaces\n", "interfaces");
		foreach $k (sort { $s1{$b} <=> $s1{$a} } keys %s1) {
			printf("  %5.2f  %-${nb_len}d  %-10s\n", $s1{$k}/$total*100,$s1{$k},$k); 
		}
	}
}
}





sub init_graph {
if ( $GD == 4 ) {
	my $func = shift;
	my $graph = shift;
	if ( $graph eq "pie" ) {
		$graphiq = GD::Graph::pie->new(250, 250);
		$graphiq->set( 	title => 'Graph') or die $graphiq->error;
		$gd = $graphiq->plot([\@list2, \@list1]) or die $graphiq->error;
	} elsif ( $graph eq "bars" ) {
		$graphiq = GD::Graph::bars->new(700, 300);
		if ( $func eq "hours2" ) {
			$graphiq->set( 	title => 'Number of Events by Hours',
				x_label => "Hours",
				y_label => "Events",
				dclrs => ['blue','green','red','cyan'],
				bar_spacing => 1,
				bar_width => 3,
				long_ticks => 1) or die $graphiq->error;
				$graphiq->set_legend('Low events','Medium events','High event','Unknown events');
				$gd = $graphiq->plot([\@list2, \@listlow, \@listmedium, \@listhigh, \@listunknown]) or die $graphiq->error;
		}
	} elsif ($graph eq "lines" ) {
		$graphiq = GD::Graph::lines->new(700, 300);
		if ( $func eq "days2" ) {
			$graphiq->set( 	title => 'Number of Severity Events by Days',
				x_label => "Days",
				y_label => "Events",
				line_types => [1, 1, 1, 1],
				dclrs => ['blue','green','red','cyan'],
				) or die $graphiq->error;
			$graphiq->set_legend('Low events','Medium events','High event','Unknown events');
			$gd = $graphiq->plot([\@list2, \@listlow, \@listmedium, \@listhigh, \@listunknown]) or die $graphiq->error;
		}
	} elsif ($graph eq "area" ) {
		$graphiq = GD::Graph::area->new(700, 300);
		if ( $func eq "days1" ) {
			$graphiq->set( 	title => 'Number of Events by Days',
				x_label => "Days",
				y_label => "Events",
				) or die $graphiq->error;
			$gd = $graphiq->plot([\@list2, \@list1]) or die $graphiq->error;
		}
		if ( $func eq "hours1" ) {
			$graphiq->set( 	title => 'Number of Events by Hours',
				x_label => "Hours",
				y_label => "Events") or die $graphiq->error;
				$gd = $graphiq->plot([\@list2, \@list1]) or die $graphiq->error;
		}
	}

	open(IMG, '>'.$val_opt_u.$graph_name._.$func.'.'.$val_opt_g) or die $val_opt_u.$graph_name._.$func.".".$val_opt_g;
	binmode IMG;
	$opton = $val_opt_g;
	print IMG $gd->$opton;
	close (IMG);
	# undef @list1;
	# undef @list2;
	undef @listlow;
	undef @listmedium;
	undef @listhigh;
	undef @listunknown;
} else {
	print "Charts generation not available, please to check your installation !!!\n";
	print "\n";
	print "Uncomment this variables :\n";
	print "\tuse GD::Graph::pie; \$GD = 1;\n";
	print "\tuse GD::Graph::bars; \$GD = 2;\n";
	print "\tuse GD::Graph::lines; \$GD = 3;\n";
	print "\tuse GD::Graph::area; \$GD = 4;\n";
	print "\t\n";
	print "\n";
	print "And verify you have the good perl librairies.\n";
}
}



sub nids {
if ($opt_h == 1) {
	@list1 = ();
	@list2 = ();
	print FILEOUT ("<h3><CENTER><a name=\"nids\" HREF=\"#top\">The distribution of event by Host</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=0 ALIGN=center><TR><TD><TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Sonde</td></tr>");
	foreach $k (sort { $s13{$b} <=> $s13{$a} } keys %s13) {
		printf FILEOUT (("<tr class=TB><td>%2.2f</td><td>%-${nb_len}d</td><td>%-32s</td></tr>\n", $s13{$k}/$total*100,$s13{$k},$k));
		push @list1 ,($s13{$k});
		push @list2 ,("$k");
	}
	if ( $opt_g == 1 ) {
		init_graph("nids","pie");
		print FILEOUT ("</TABLE></TD><TD WIDTH=300 ALIGN=right><IMG SRC=".$graph_name._nids.".".$val_opt_g."></TD></TR></TABLE><BR>\n");
	} else {
		print FILEOUT ("</TABLE></TD></TR></TABLE><BR>\n");
	}
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "nids() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "The distribution of event by Host\n";
		$linelength = 50;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". keys(%s13) ." of ". keys(%s13) ." ###\n");
		print FILEOUT ("    %    nb      Sondes\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort { $s13{$b} <=> $s13{$a} } keys %s13) {
			printf FILEOUT ("  %5.2f  %-${nb_len}d  %-32s\n", $s13{$k}/$total*100,$s13{$k},$k); 
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("The distribution of event by Host\n", "nids");
		foreach $k (sort { $s13{$b} <=> $s13{$a} } keys %s13) {
			printf("  %5.2f  %-${nb_len}d  %-32s\n", $s13{$k}/$total*100,$s13{$k},$k); 
		}
	}
}
}


sub proto {
if ($opt_h == 1) {
	@list1 = ();
	@list2 = ();
	print FILEOUT ("<h3><CENTER><a name=\"proto\" HREF=\"#top\">The distribution of event by protocoles</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=0 ALIGN=center><TR><TD><table border=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Protocoles</td></tr>");
	foreach $k (sort { $s11{$b} <=> $s11{$a} } keys %s11) {
		printf FILEOUT (("<tr class=TB><td>%2.2f</td><td>%-${nb_len}d</td><td>%-32s</td></tr>\n", $s11{$k}/$total*100,$s11{$k},$k));
		push @list1 ,($s11{$k});
		push @list2 ,("$k");
	}
	if ( $opt_g == 1 ) {
		init_graph("proto","pie");
		print FILEOUT ("</TABLE></TD><TD WIDTH=300 ALIGN=right><IMG SRC=".$graph_name._proto.".".$val_opt_g."></TD></TR></TABLE><BR>\n");
	} else {
		print FILEOUT ("</TABLE></TD></TR></TABLE><BR>\n");
	}
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "proto() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "The distribution of event by protocoles\n";
		$linelength = 50;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". keys(%s11) ." of ". keys(%s11) ." ###\n");
		print FILEOUT ("    %    nb      Protocoles\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort { $s11{$b} <=> $s11{$a} } keys %s11) {
			printf FILEOUT ("  %5.2f  %-${nb_len}d  %-32s\n", $s11{$k}/$total*100,$s11{$k},$k); 
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("The distribution of event by protocoles\n", "proto");
		foreach $k (sort { $s11{$b} <=> $s11{$a} } keys %s11) {
			printf("  %5.2f  %-${nb_len}d  %-32s\n", $s11{$k}/$total*100,$s11{$k},$k); 
		}
	}
}
}


sub stateful {
if ($opt_h == 1) {
#	open (FILEOUT, ">>$val_opt_u$val_opt_h") or die "Can no access file : $val_opt_u$val_opt_h\n";
	print FILEOUT ("<h3><CENTER><a name=\"stateful\" HREF=\"#top\">The distribution of stateful problems</a><CENTER></h3>\n");
	print FILEOUT ("<table border=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Processor</td></tr>");
	foreach $k (sort { $s17{$b} <=> $s17{$a} } keys %s17) {
		printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-32s</td></tr>", $s17{$k}/$total*100,$s17{$k},$k) if $k ne "none";
	}
	print FILEOUT ("</TD></TR></TABLE><BR>\n");
#	close (FILEOUT);
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "stateful() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "The distribution of stateful problems\n";
		$linelength = 40;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $anomaly ." of ". $anomaly ." ###\n");
		print FILEOUT ("    %    nb      Preprocessor\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort { $s17{$b} <=> $s17{$a} } keys %s17) {
			printf FILEOUT ("  %5.2f  %-${nb_len}d  %-32s\n", $s17{$k}/$total*100,$s17{$k},$k) if $k ne "none"; 
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("The distribution of stateful problems\n", "stateful");
		foreach $k (sort { $s17{$b} <=> $s17{$a} } keys %s17) {
			printf("  %5.2f  %-${nb_len}d  %-32s\n", $s17{$k}/$total*100,$s17{$k},$k) if $k ne "none"; 
		}
	}
}
}


sub same_src_dst_attack {
$i=0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s0) ) ) {
	$n = keys %s0;
} else {
	$n = $val_opt_n;
}
if ($opt_h == 1) {
	print FILEOUT ("<h3><CENTER><a name=\"same_src_dst_attack\" href=\"#top\">Percentage and number of attacks from a host to a destination</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=CENTER>\n");
	print FILEOUT ("<TR CLASS=TH align=center><td>%</td><td>Nb</td><td>IP Source</td><td>IP Destination</td><td>Attack</td></tr>");
	if ($opt_i == 1) {
		foreach $k (sort { $s0{$a} <=> $s0{$b} } keys %s0) { 
			@_ = split ",",$k;
			printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td><td>%-${addr_len}s</td><td>%-${attack_len}s</td></tr>\n", $s0{$k}/$total*100, $s0{$k},$_[1],$_[0],$_[2]) if $i < $n;
			++$i;
		}
	} else {
		foreach $k (sort { $s0{$b} <=> $s0{$a} } keys %s0) { 
			@_ = split ",",$k;
			printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td><td>%-${addr_len}s</td><td>%-${attack_len}s</td></tr>\n", $s0{$k}/$total*100, $s0{$k},$_[1],$_[0],$_[2]) if $i < $n;
			++$i;
		}
	}
	print FILEOUT ("</table><BR>\n");
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "same_src_dst_attack() :\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "The number of attacks from same host to same destination using same method\n";
		$linelength = 13 + $nb_len + 4 + $addr_len + 4 + $addr_len + 4 + $attack_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s0) ." ###\n");
		print FILEOUT ("    %    nb      IP source        IP destination   Attack\n");
		print FILEOUT ( '=' x $linelength, "\n");
		if ($opt_i == 1) {
			foreach $k (sort { $s0{$a} <=> $s0{$b} } keys %s0) { 
				@_ = split ",",$k;
				printf FILEOUT ("  %-5.2f  %-${nb_len}d  %-${addr_len}s  %-${addr_len}s  %-10s\n",
				$s0{$k}/$total*100, $s0{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i;
			}
		} else {
			foreach $k (sort { $s0{$b} <=> $s0{$a} } keys %s0) { 
				@_ = split ",",$k;
				printf FILEOUT ("  %-5.2f  %-${nb_len}d  %-${addr_len}s  %-${addr_len}s  %-10s\n",
				$s0{$k}/$total*100, $s0{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i;
			}
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("The number of attacks from same host to same destination using same method\n", "same_src_dst_attack");
		if ($opt_i == 1) {
			foreach $k (sort { $s0{$a} <=> $s0{$b} } keys %s0) { 
				@_ = split ",",$k;
				printf("  %-5.2f  %-${nb_len}d  %-${addr_len}s  %-${addr_len}s  %-10s\n",
				$s0{$k}/$total*100, $s0{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i;
			}
		} else {
			foreach $k (sort { $s0{$b} <=> $s0{$a} } keys %s0) { 
				@_ = split ",",$k;
				printf("  %-5.2f  %-${nb_len}d  %-${addr_len}s  %-${addr_len}s  %-10s\n",
				$s0{$k}/$total*100, $s0{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i;
			}
		}
	}
}
}


# to see how many attacks launched from one host
sub same_src_attack {
$i=0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s2) ) ) {
	$n = keys %s2;
} else {
	$n = $val_opt_n;
}
if ($opt_h == 1) {
	print FILEOUT ("<h3><CENTER><a name=\"same_src_attack\" href=\"#top\">Percentage and number of attacks from one host to any with same method</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 align=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>IP Source</td><td>Attack</td><td>Severity</td></tr>");
	if ($opt_i == 1) {
		foreach $k (sort { $s2{$a} <=> $s2{$b} } keys %s2) {
			@_ = split ",",$k;
			$STYLE = init_color($_[2]);
			printf FILEOUT ("<tr class=$STYLE><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td><td>%-${attack_len}s</td><td>%-${server_len}s</td></tr>\n", $s2{$k}/$total*100, $s2{$k},$_[1],$_[0],$_[2]) if $i < $n;
			++$i
		}
	} else {
		foreach $k (sort { $s2{$b} <=> $s2{$a} } keys %s2) {
			@_ = split ",",$k;
			$STYLE = init_color($_[2]);
			printf FILEOUT ("<tr class=$STYLE><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td><td>%-${attack_len}s</td><td>%-${server_len}s</td></tr>\n", $s2{$k}/$total*100, $s2{$k},$_[1],$_[0],$_[2]) if $i < $n;
			++$i;
		}
	}
	print FILEOUT ("</table><BR>\n");
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "same_src_attack() :\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "Percentage and number of attacks from one host to any with same method\n";
		$linelength = 11 + $nb_len + 4 + $addr_len + 4 + $attack_len + 4 + $sever_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s2) ." ###\n");
		print FILEOUT ("    %    nb      IP source        Attack                                                                  Severity\n");
		print FILEOUT ( '=' x $linelength, "\n");
		if ($opt_i == 1) {
			foreach $k (sort { $s2{$a} <=> $s2{$b} } keys %s2) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${attack_len}s  %-${server_len}s\n",$s2{$k}/$total*100, $s2{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i
			}
		} else {
			foreach $k (sort { $s2{$b} <=> $s2{$a} } keys %s2) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${attack_len}s  %-${sever_len}s\n",$s2{$k}/$total*100, $s2{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i;
			}
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("Percentage and number of attacks from one host to any with same method\n", "same_src_attack");  
		if ($opt_i == 1) {
			foreach $k (sort { $s2{$a} <=> $s2{$b} } keys %s2) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${attack_len}s  %-${server_len}s\n",
				$s2{$k}/$total*100, $s2{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i
			}
		} else {
			foreach $k (sort { $s2{$b} <=> $s2{$a} } keys %s2) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${attack_len}s  %-${sever_len}s\n",
				$s2{$k}/$total*100, $s2{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i;
			}
		}
	}
}
}


# to see how many attacks received by one host (destination correlated)
sub same_dst_attack {
$i=0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s3) ) ) {
	$n = keys %s3;
} else {
	$n = $val_opt_n;
}
if ($opt_h == 1) {
#	open (FILEOUT, ">>$val_opt_u$val_opt_h") or die "Can no access file : $val_opt_u$val_opt_h\n";
	print FILEOUT ("<h3><CENTER><a name=\"same_dst_attack\" href=\"#top\">Percentage and number of attacks to one host from any with same method</a><CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 align=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>IP Source</td><td>Attack</td><td>Severity</td></tr>");
	if ($opt_i == 1) {
		foreach $k (sort { $s3{$a} <=> $s3{$b} } keys %s3) {
			@_ = split ",",$k;
			$STYLE = init_color($_[2]);
			printf FILEOUT ("<tr class=$STYLE><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td><td>%-${attack_len}s</td><td>%-${sever_len}s</td></tr>\n",$s3{$k}/$total*100 , $s3{$k},$_[1],$_[0],$_[2]) if $i < $n;
			++$i;
		}
	} else {
		foreach $k (sort { $s3{$b} <=> $s3{$a} } keys %s3) {
			@_ = split ",",$k;
			$STYLE = init_color($_[2]);
			printf FILEOUT ("<tr class=$STYLE><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td><td>%-${attack_len}s</td><td>%-${sever_len}s</td></tr>\n",$s3{$k}/$total*100 , $s3{$k},$_[1],$_[0],$_[2]) if $i < $n;
			++$i;
		}
	}
	print FILEOUT ("</table><BR>\n");
#	close (FILEOUT);
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "same_dst_attack() :\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "Percentage and number of attacks to one host from any with same method\n";
		$linelength = 13 + $nb_len + 4 + $addr_len + 4 + $attack_len + 4 + $sever_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s3) ." ###\n");
		print FILEOUT ("    %    nb      IP destination   Attack                                                                  Severity\n");
		print FILEOUT ( '=' x $linelength, "\n");
		if ($opt_i == 1) {
			foreach $k (sort { $s3{$a} <=> $s3{$b} } keys %s3) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${attack_len}s  %-${sever_len}s\n",$s3{$k}/$total*100 ,$s3{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i;
			}
		} else {
			foreach $k (sort { $s3{$b} <=> $s3{$a} } keys %s3) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${attack_len}s  %-${sever_len}s\n",$s3{$k}/$total*100 ,$s3{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i;
			}
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("Percentage and number of attacks to one host from any with same method\n", "same_dst_attack");
		if ($opt_i == 1) {
			foreach $k (sort { $s3{$a} <=> $s3{$b} } keys %s3) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${attack_len}s  %-${sever_len}s\n",$s3{$k}/$total*100 ,
				$s3{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i;
			}
		} else {
			foreach $k (sort { $s3{$b} <=> $s3{$a} } keys %s3) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${attack_len}s  %-${sever_len}s\n",$s3{$k}/$total*100 ,
				$s3{$k},$_[1],$_[0],$_[2]) if $i < $n;
				++$i;
			}
		}
	}
}
}


# to see the popularity of one attack method
sub attack {
if ($opt_h == 1) {
	print FILEOUT ("<h3><CENTER><a name=\"attack\" href=\"#top\">The distribution of attack methods</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Attack</td><td>Priority</td><td>Severity</td></tr>");
	if ($opt_i == 1) {
		foreach $k (sort { $s4{$a} <=> $s4{$b} } keys %s4) {
			@_ = split ",",$k;
			if ( ($link{$_[0]} =~ /(^.+),(.*$)/) && ($RULES == 1) ) {
				$url = init_url($1);
				printf FILEOUT ("<tr class=TB><td>%2.2f</td><td>%-${nb_len}d</td><td><a href=$url$2>%-${attack_len}s</a></td><td>%-${prior_len}d</td><td>%-${sever_len}s</td><td>%-20s</td></tr>\n", $s4{$k}/$total*100,$s4{$k},$_[0],$_[1],$_[2]); 
				++$i;
			} else {
				printf FILEOUT ("<tr class=TB><td>%2.2f</td><td>%-${nb_len}d</td><td>%-${attack_len}s</td><td>%-${prior_len}d</td><td>%-${sever_len}s</td><td>%-20s</td></tr>\n", $s4{$k}/$total*100,$s4{$k},$_[0],$_[1],$_[2]); 
				++$i;
			}
		}
	} else {
		foreach $k (sort { $s4{$b} <=> $s4{$a} } keys %s4) {
			@_ = split ",",$k;
			if ( ($link{$_[0]} =~ /(^.+),(.*$)/ ) && ($RULES == 1) ) {
				$url = init_url($1);
				printf FILEOUT ("<tr class=TB><td>%2.2f</td><td>%-${nb_len}d</td><td><a href=$url$2>%-${attack_len}s</a></td><td>%-${prior_len}d</td><td>%-${sever_len}s</td></tr>\n", $s4{$k}/$total*100,$s4{$k},$_[0],$_[1],$_[2]); 
				++$i;
			} else {
				printf FILEOUT ("<tr class=TB><td>%2.2f</td><td>%-${nb_len}d</td><td>%-${attack_len}s</td><td>%-${prior_len}d</td><td>%-${sever_len}s</td></tr>\n", $s4{$k}/$total*100,$s4{$k},$_[0],$_[1],$_[2]); 
				++$i;
			}
		}
	}
	print FILEOUT ("</table><BR>\n");
#	close (FILEOUT);
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "attack() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "The distribution of attack methods\n";
		$linelength = 13 + $nb_len + 4 + $attack_len + 4 + $prior_len + 4 + $sever_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". keys(%s4) ." of ". keys(%s4) ." ###\n");
		print FILEOUT ("    %    nb      Attack                                                           Priority Severity\n");
		print FILEOUT ( '=' x $linelength, "\n");
		if ($opt_i == 1) {
			foreach $k (sort { $s4{$a} <=> $s4{$b} } keys %s4) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${attack_len}s  %-${prior_len}d %-${sever_len}s\n", $s4{$k}/$total*100,$s4{$k},$_[0],$_[1],$_[2]); 
				++$i;
			}
		} else {
			foreach $k (sort { $s4{$b} <=> $s4{$a} } keys %s4) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${attack_len}s  %-${prior_len}d %-${sever_len}s\n", $s4{$k}/$total*100,$s4{$k},$_[0],$_[1],$_[2]); 
				++$i;
			}
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {		
		section_header("The distribution of attack methods\n", "attack");
		if ($opt_i == 1) {
			foreach $k (sort { $s4{$a} <=> $s4{$b} } keys %s4) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %-${attack_len}s  %-${prior_len}d %-${sever_len}s\n", $s4{$k}/$total*100,$s4{$k},$_[0],$_[1],$_[2]); 
				++$i;
			}
		} else {
			foreach $k (sort { $s4{$b} <=> $s4{$a} } keys %s4) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %-${attack_len}s  %-${prior_len}d %-${sever_len}s\n", $s4{$k}/$total*100,$s4{$k},$_[0],$_[1],$_[2]); 
				++$i;
			}
		}
	}
}
}


# to see the popularity of one source host 
sub same_class {
if ($opt_h == 1) {
#	open (FILEOUT, ">>$val_opt_u$val_opt_h") or die "Can no access file : $val_opt_u$val_opt_h\n";
	print FILEOUT ("<h3><CENTER><a name=\"same_class\" href=\"#top\">The distribution of classification method</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Classification</td><td>Severity</td></tr>");
	if ($opt_i == 1) {
		foreach $k (sort { $s10{$a} <=> $s10{$b} } keys %s10) {
			@_ = split ",",$k;
			$STYLE = init_color($_[1]);
			printf FILEOUT ("<tr class=$STYLE><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${class_len}s</td><td>%-${server_len}s</td></tr>\n", $s10{$k}/$total*100,$s10{$k},$_[0],$_[1]); 
		}
	} else {
		foreach $k (sort { $s10{$b} <=> $s10{$a} } keys %s10) {
			@_ = split ",",$k;
			$STYLE = init_color($_[1]);
			printf FILEOUT ("<tr class=$STYLE><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${class_len}s</td><td>%-${server_len}s</td></tr>\n", $s10{$k}/$total*100,$s10{$k},$_[0],$_[1]); 
		}
	}
	print FILEOUT ("</table><BR>\n");
#	close (FILEOUT);
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "same_class() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "The distribution of classification method\n";
		$linelength = 13 + $nb_len + 4 + $class_len + 4 + $sever_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". keys(%s10) ." of ". keys(%s10) ." ###\n");
		print FILEOUT ("    %    nb       Classification                                               Severity\n");
		print FILEOUT ( '=' x $linelength, "\n");
		if ($opt_i == 1) {
			foreach $k (sort { $s10{$a} <=> $s10{$b} } keys %s10) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${class_len}s  %-${server_len}s\n", $s10{$k}/$total*100,$s10{$k},$_[0],$_[1]); 
			}
		} else {
			foreach $k (sort { $s10{$b} <=> $s10{$a} } keys %s10) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${class_len}s  %-${sever_len}s\n", $s10{$k}/$total*100,$s10{$k},$_[0],$_[1]); 
			}
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {		
		section_header("The distribution of classification method\n", "same_class");
		if ($opt_i == 1) {
			foreach $k (sort { $s10{$a} <=> $s10{$b} } keys %s10) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %-${class_len}s  %-${server_len}s\n", $s10{$k}/$total*100,$s10{$k},$_[0],$_[1]); 
			}
		} else {
			foreach $k (sort { $s10{$b} <=> $s10{$a} } keys %s10) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %-${class_len}s  %-${sever_len}s\n", $s10{$k}/$total*100,$s10{$k},$_[0],$_[1]); 
			}
		}
	}
}
}



# to see the popularity of one source host 
sub attack_src {
$i=0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s5) ) ) {
	$n = keys %s5;
} else {
	$n = $val_opt_n;
}
if ( $opt_h == 1 ) {
	print FILEOUT ("<h3><CENTER><a name=\"attack_src\" href=\"#top\">To see the popularity of one source host ( ". $val_opt_n ." of ". keys(%s5) ." )</a><CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	if ($opt_r) {
		print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>IP Source</td><td>Resolve</td><td>Domain</td></tr>");
	} else {
		print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>IP Source</td></tr>");
	}
	
	if ($opt_i == 1) {
		foreach $k (sort { $s5{$a} <=> $s5{$b} } keys %s5) {
			if ($i < $n) {
				if ($opt_r) {
					$host = resolve ($k);
					$src_host = $host if ($host ne $k);
					$STYLE = init_color($src_host);
					$src_host =~ /(\w+$)/;
					printf FILEOUT ("<tr class=$STYLE><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td><td>%-${addr_len}s</td><td>%-${domain_len}s</td></tr>\n",$s5{$k}/$total*100,$s5{$k},$k,$src_host,$DomainName{$1});
				} else {
					printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td></tr>\n", $s5{$k}/$total*100,$s5{$k},$k);
				}
			}
		++$i;
		}
	} else {
		foreach $k (sort { $s5{$b} <=> $s5{$a} } keys %s5) {
			if ($i < $n) {
				if ($opt_r) {
					$host = resolve ($k);
					$src_host = $host if ($host ne $k);
					$STYLE = init_color($src_host);
					$src_host =~ /(\w+$)/;
					printf FILEOUT ("<tr class=$STYLE><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td><td>%-${resolve_len}s</td><td>%-${domain_len}s</td></tr>\n",$s5{$k}/$total*100,$s5{$k},$k,$src_host,$DomainName{$1});
				} else {
					 printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td></tr>\n", $s5{$k}/$total*100,$s5{$k},$k);
				}
			}
		++$i;
		}
	}
	print FILEOUT ("</table><BR>\n");
#	close (FILEOUT);
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "attack_src() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "To see the popularity of one source host\n";
		if ($opt_r) {
			$linelength = 11 + $nb_len + 2 + $addr_len + 2 + $resolve_len + 2 + $domain_len;
			print FILEOUT ( '=' x $linelength, "\n");
			print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s5) ." ###\n");
			print FILEOUT ("    %    nb      IP source        Resolve                                             Domain\n");
			print FILEOUT ( '=' x $linelength, "\n");
		} else {
			$linelength = 13 + $nb_len + 4 + $addr_len;
			print FILEOUT ( '=' x $linelength, "\n");
			print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s5) ." ###\n");
			print FILEOUT ("    %    nb      IP source\n");
			print FILEOUT ( '=' x $linelength, "\n");
		}
		if ($opt_i == 1) {
			foreach $k (sort { $s5{$a} <=> $s5{$b} } keys %s5) {
				if ($i < $n) {
					if ($opt_r) {
						$host = resolve ($k);
						$src_host = $host if ($host ne $k);
						$src_host =~ /(\w+$)/;
						printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${resolve_len}s  %-${domain_len}s\n", $s5{$k}/$total*100,$s5{$k},$k,$src_host,$DomainName{$1});
					} else {
						printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s\n", $s5{$k}/$total*100,$s5{$k},$k) if $i < $nb; 
					}
				}
			++$i;
			}
		} else {
			foreach $k (sort { $s5{$b} <=> $s5{$a} } keys %s5) {
				if ($i < $n) {
					if ($opt_r) {
						$host = resolve ($k);
						$src_host = $host if ($host ne $k);
						$src_host =~ /(\w+$)/;
						printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${resolve_len}s  %-${domain_len}s\n", $s5{$k}/$total*100,$s5{$k},$k,$src_host,$DomainName{$1});
					} else {
						printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s\n", $s5{$k}/$total*100,$s5{$k},$k);
					}
				}
			++$i;
			}
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {		
		if ($opt_r) {
			section_header("To see the popularity of one source host\n", "attack_src_resolve");
		} else {
			section_header("To see the popularity of one source host\n", "attack_src");
		}
		if ($opt_i == 1) {
			foreach $k (sort { $s5{$a} <=> $s5{$b} } keys %s5) {
				if ($i < $n) {
					if ($opt_r) {
						$host = resolve ($k);
						$src_host = $host if ($host ne $k);
						$src_host =~ /(\w+$)/;
						$s40{"$1"}++;
						printf("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${resolve_len}s  %-${domain_len}s\n", $s5{$k}/$total*100,$s5{$k},$k,$src_host,$DomainName{$1});
					} else {
						printf("  %5.2f  %-${nb_len}d  %-${addr_len}s\n", $s5{$k}/$total*100,$s5{$k},$k) if $i < $nb; 
					}
				}
			++$i;
			}
		} else {
			foreach $k (sort { $s5{$b} <=> $s5{$a} } keys %s5) {
				if ($i < $n) {
					if ($opt_r) {
						$host = resolve ($k);
						$src_host = $host if ($host ne $k);
						$src_host =~ /(\w+$)/;
#						$s40{"$1"}++;
						printf("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${resolve_len}s  %-${domain_len}s\n", $s5{$k}/$total*100,$s5{$k},$k,$src_host,$DomainName{$1});
					} else {
						printf("  %5.2f  %-${nb_len}d  %-${addr_len}s\n", $s5{$k}/$total*100,$s5{$k},$k);
					}
				}
			++$i;
			}
		}
	}
}
}




sub domain_src {
$i=0;
foreach $k (sort { $s5{$b} <=> $s5{$a} } keys %s5) {
	$host = resolve ($k);
	$src_host = $host if ($host ne $k);
	$src_host =~ /(\w+$)/;
	$s40{"$1"}++;
}
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s40) ) ) {
	$n = keys %s40;
} else {
	$n = $val_opt_n;
}
if ( $opt_h == 1 ) {
	@list1 = ();
	@list2 = ();
	print FILEOUT ("<h3><CENTER><a name=\"domain_src\" HREF=\"#top\">To see the popularity of one domain</a><CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=0 ALIGN=center><TR><TD><TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Domain</td></tr>");
	if ($opt_i == 1) {
		foreach $k (sort { $s40{$a} <=> $s40{$b} } keys %s40) {
			if ( $i < $n ) {
				$STYLE = init_color($k);
				printf FILEOUT ("<tr class=$STYLE><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${domain_len}s</td></tr>\n", $s40{$k}/(keys %s5)*100,$s40{$k},$DomainName{$k});
				push @list1 ,($s40{$k});
				push @list2 ,("$k");
				++$i;
			}
		}
	} else {
		foreach $k (sort { $s40{$b} <=> $s40{$a} } keys %s40) {
			if ( $i < $n ) {
				$STYLE = init_color($k);
				printf FILEOUT ("<tr class=$STYLE><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${domain_len}s</td></tr>\n", $s40{$k}/(keys %s5)*100,$s40{$k},$DomainName{$k});
				push @list1 ,($s40{$k});
				push @list2 ,("$k");
				++$i;
			}
		}
	}
	if ( $opt_g == 1 ) {
		init_graph("domain","pie");
		print FILEOUT ("</TABLE></TD><TD WIDTH=300 ALIGN=right><IMG SRC=".$graph_name._domain.".".$val_opt_g."></TD></TR></TABLE><BR>\n");
	} else {
		print FILEOUT ("</TABLE></TD></TR></TABLE><BR>\n");
	}
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "domain_crc() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "To see the popularity of one domain\n";
		$linelength = 11 + $domain_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s40) ." ###\n");
		print FILEOUT ("    %    nb      Domain\n");
		print FILEOUT ( '=' x $linelength, "\n");
		if ($opt_i == 1) {
			foreach $l (sort { $s40{$a} <=> $s40{$b} } keys %s40) {
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${domain_len}s\n", $s40{$l}/(keys %s5)*100,$s40{$l},$DomainName{$l});
			}
		} else {
			foreach $l (sort { $s40{$b} <=> $s40{$a} } keys %s40) {
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${domain_len}s\n", $s40{$l}/(keys %s5)*100,$s40{$l},$DomainName{$l});
			}
		}	
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");	
	} else {		
		section_header("To see the popularity of one domain\n", "domain_src");
		if ($opt{i}) {
			foreach $l (sort { $s40{$a} <=> $s40{$b} } keys %s40) {
				printf("  %5.2f  %-${nb_len}d  %-${domain_len}s\n", $s40{$l}/(keys %s5)*100,$s40{$l},$DomainName{$l}) if ( $i < $n );
				++$i;
			}
		} else {
			foreach $l (sort { $s40{$b} <=> $s40{$a} } keys %s40) {
				printf("  %5.2f  %-${nb_len}d  %-${domain_len}s\n", $s40{$l}/(keys %s5)*100,$s40{$l},$DomainName{$l}) if ( $i < $n );
				++$i;
			}
		}
	}
}
}



# to see the popularity of one destination host
sub attack_dst {
$i=0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s6) ) ) {
	$n = keys %s6;
} else {
	$n = $val_opt_n;
}
if ( $opt_h == 1 ) {
	print FILEOUT ("<h3><CENTER><a name=\"attack_dst\" href=\"#top\">To see the popularity of one destination host ( ". $val_opt_n ." of ". keys(%s6) ." )</a><CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	if ($opt_r) {
		print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>IP Destination</td><td>Resolve</td></tr>");
	} else {
		print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>IP Destination</td></tr>");
	}

	if ($opt_i == 1) {
		foreach $k (sort { $s6{$a} <=> $s6{$b} } keys %s6) {
			if ($opt_r) {
				$host = resolve ($k);
				$src_host = $host if ($host ne $k);
				printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td><td>%-${resolve_len}s</td></tr>\n",$s6{$k}/$total*100,$s6{$k},$k,$src_host) if $i < $n;
			} else {
				printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td></tr>\n", $s6{$k}/$total*100,$s6{$k},$k) if $i < $n;
			}
		++$i;
		}
	} else {
		foreach $k (sort { $s6{$b} <=> $s6{$a} } keys %s6) {
			if ($opt_r) {
				$host = resolve ($k);
				$src_host = $host if ($host ne $k);
				printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td><td>%-${resolve_len}s</td></tr>\n",$s6{$k}/$total*100,$s6{$k},$k,$src_host) if $i < $n;
			} else {
				printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${addr_len}s</td></tr>\n", $s6{$k}/$total*100,$s6{$k},$k) if $i < $val_opt_n;
			}
		++$i;
		}
	}
	print FILEOUT ("</table><BR>\n");
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "attack_dst() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "To see the popularity of one destination host\n";
		if ($opt_r) {
			$linelength = 11 + $nb_len + 2 + $addr_len + 2 + $resolve_len + 2 + $domain_len;
			print FILEOUT ( '=' x $linelength, "\n");
			print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s6) ." ###\n");
			print FILEOUT ("    %    nb      IP destination   Resolve\n");
			print FILEOUT ( '=' x $linelength, "\n");
		} else {
			$linelength = 13 + $nb_len + 4 + $addr_len;
			print FILEOUT ( '=' x $linelength, "\n");
			print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s6) ." ###\n");
			print FILEOUT ("    %    nb      IP destination\n");
			print FILEOUT ( '=' x $linelength, "\n");
		}

		if ($opt_i == 1) {
			foreach $k (sort { $s6{$a} <=> $s6{$b} } keys %s6) {
				if ($opt_r) {
					$host = resolve ($k);
					$src_host = $host if ($host ne $k);
					printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${resolve_len}s\n", $s6{$k}/$total*100,$s6{$k},$k,$src_host) if $i < $n;
				} else {
					printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s\n", $s6{$k}/$total*100,$s6{$k},$k) if $i < $n; 
				}
			++$i;
			}
		} else {
			foreach $k (sort { $s6{$b} <=> $s6{$a} } keys %s6) {
				if ($opt_r) {
					$host = resolve ($k);
					$src_host = $host if ($host ne $k);
					printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${resolve_len}s\n", $s6{$k}/$total*100,$s6{$k},$k,$src_host) if $i < $n;
				} else {
					printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s\n", $s6{$k}/$total*100,$s6{$k},$k) if $i < $n; 
				}
			++$i;
			}
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {
		if ($opt_r) {
			section_header("To see the popularity of one destination host\n", "attack_dst_resolve");
		} else {
			section_header("To see the popularity of one destination host\n", "attack_dst");
		}
		if ($opt_i == 1) {
			foreach $k (sort { $s6{$a} <=> $s6{$b} } keys %s6) {
				if ($opt_r) {
					$host = resolve ($k);
					$src_host = $host if ($host ne $k);
					printf("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${resolve_len}s\n", $s6{$k}/$total*100,$s6{$k},$k,$src_host) if $i < $n;
				} else {
					printf("  %5.2f  %-${nb_len}d  %-${addr_len}s\n", $s6{$k}/$total*100,$s6{$k},$k) if $i < $n; 
				}
			++$i;
			}
		} else {
			foreach $k (sort { $s6{$b} <=> $s6{$a} } keys %s6) {
				if ($opt_r) {
					$host = resolve ($k);
					$src_host = $host if ($host ne $k);
					printf("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-${resolve_len}s\n", $s6{$k}/$total*100,$s6{$k},$k,$src_host) if $i < $n;
				} else {
					printf("  %5.2f  %-${nb_len}d  %-${addr_len}s\n", $s6{$k}/$total*100,$s6{$k},$k) if $i < $n; 
				}
			++$i;
			}
		}
	}

}
}



# to see the activity by hour 
sub hour {
$max = 0;
if ( $opt_h == 1 ) {
	@list1 = ();
	@list2 = ();
	print FILEOUT ("<H3><CENTER><A NAME=\"hour\" HREF=\"#top\">The distribution of attack by hour</A><CENTER></H3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<TR CLASS=TH ALIGN=center><TD>Hour</TD><TD>Nb</TD><TD>%</TD><TD>Graph</TD></TR>");
	foreach $k (%s7) {
		$max = $s7{$k} if ($s7{$k} > $max);
	}
	my $ratio = $max/$total*100;
	
	foreach $k (sort { $a <=> $b } keys %s7) {
		my $num = $s7{$k}/$total*(50000/$ratio);
		printf FILEOUT ("<TR CLASS=TB><TD>%${hour_len}dh</TD><TD>%-${nb_len}d</TD><TD>%-2.2f</TD><TD WIDTH=$num><HR NOSHADE ALIGN=left SIZE=10 COLOR=#CCCCCC  WIDTH=%3d ></TD></TR>\n", $k,$s7{$k},$s7{$k}/$total*100,$num); 
		push @list1 ,($s7{$k});
		push @list2 ,($k);
	}
	if ( $opt_g == 1 ) {
		init_graph("hours1","area") if ( $opt_g == 1 );
		print FILEOUT ("<TABLE BORDER=0 ALIGN=center><TR><TD><IMG SRC=".$graph_name._hours1.".".$val_opt_g."></TD></TR></TABLE><BR>\n");
	} else {
		print FILEOUT ("</TD></TR></TABLE><BR>\n");
	}

	if (( $logids == 1 ) and ( $opt_g == 1 )) {
		$compt = 1;
		foreach $k (sort { $a <=> $b } keys %s8) {
			@_ = split ",",$k;
			$beforeday = $_[0];
			$belowday = $beforeday if ( $compt == 1 );
			if ( $belowday < $beforeday ) {
				if ( $low ) {
					push @listlow ,($low);
					undef $low;
				} else {
					push @listlow ,(0);
				}
				if ( $medium ) {
					push @listmedium ,($medium);
					undef $medium;
				} else {
					push @listmedium ,(0);
				}
				if ( $high ) {
					push @listhigh ,($high);
					undef $high;
				} else {
					push @listhigh ,(0);
				}
				if ( $unknown ) {
					push @listunknown ,($unknown);
					undef $unknown;
				} else {
					push @listunknown ,(0);
				}
			}
			if ( $_[1] eq "low") {
				$low = $s8{$k};
			} elsif ( $_[1] eq "medium" ) {
				$medium = $s8{$k};
			} elsif ( $_[1] eq "high" ) {
				$high = $s8{$k};
			} elsif ( $_[1] eq "unknown" ) {
				$unknown = $s8{$k};
			}
			$belowday = $beforeday;
			$compt ++;
		}
		if ( $low ) {
			push @listlow ,($low);
			undef $low;
		} else {
			push @listlow ,(0);
		}
		if ( $medium ) {
			push @listmedium ,($medium);
			undef $medium;
		} else {
			push @listmedium ,(0);
		}
		if ( $high ) {
			push @listhigh ,($high);
			undef $high;
		} else {
			push @listhigh ,(0);
		}
		if ( $unknown ) {
			push @listunknown ,($unknown);
			undef $unknown;
		} else {
			push @listunknown ,(0);
		}
		init_graph("hours2","bars");
		print FILEOUT ("<TABLE BORDER=0 ALIGN=center><TR><TD><IMG SRC=".$graph_name._hours2.".".$val_opt_g."></TD></TR><TR></TABLE><BR>\n");
	}
} else {
	foreach $k (%s7) {
		$max = $s7{$k} if ($s7{$k} > $max);
	}
	$ratio = $max/$total*100;
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "hour() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "The distribution of attack by hour\n";
		$linelength = 13 + $nb_len + 2 + $hour_len + 2 + $graph_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". keys(%s7) ." of ". keys(%s7) ." ###\n");
		print FILEOUT ("  Hour nb        %    Graph\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort keys %s7) {
			my $num = $s7{$k}/$total*75*(100 / $ratio);
			printf FILEOUT ("  %${hour_len}dh  %-${nb_len}d  %5.2f  %-${graph_len}s\n", $k,$s7{$k},$s7{$k}/$total*100, '#' x $num); 
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {
		section_header("The distribution of attack by hour\n", "hour");
		foreach $k (sort keys %s7) {
			my $num = $s7{$k}/$total*75*(100 / $ratio);
			printf("  %${hour_len}dh  %-${nb_len}d  %5.2f  %-${graph_len}s\n", $k,$s7{$k},$s7{$k}/$total*100, '#' x $num); 
		}
	}
}
}


sub same_hour_attack {
$i=0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s9) ) ) {
	$n = keys %s9;
} else {
	$n = $val_opt_n;
}
if ( $opt_h == 1 ) {
	print FILEOUT ("<h3><CENTER><a name=\"hour_attack\" href=\"#top\">Percentage and number of attacks by hour</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Hour</td><td>Attack</td></tr>");
	if ($opt_i == 1) {
		foreach $k (sort { $s9{$a} <=> $s9{$b} } keys %s9) {
			@_ = split ",",$k;
			printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%${hour_len}dh</td><td>%-${attack_len}s</td></tr>\n",
			$s9{$k}/$total*100, $s9{$k},$_[0],$_[1]) if $i < $n;
			++$i
		}
	} else {
		foreach $k (sort { $s9{$b} <=> $s9{$a} } keys %s9) {
			@_ = split ",",$k;
			printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%${hour_len}dh</td><td>%-${attack_len}s</td></tr>\n",
			$s9{$k}/$total*100, $s9{$k},$_[0],$_[1]) if $i < $n;
			++$i;
		}
	}
	print FILEOUT ("</table><BR>\n");
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "same_hour_attack() :\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "Percentage and number of attacks by hour\n";
		$linelength = 11 + $nb_len + 4 + $hour_len + 4 + $attack_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s9) ." ###\n");
		print FILEOUT ("    %    nb      Heure  Attack\n");
		print FILEOUT ( '=' x $linelength, "\n");
		if ($opt_i == 1) {
			foreach $k (sort { $s9{$a} <=> $s9{$b} } keys %s9) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %${hour_len}dh    %-${attack_len}s\n",
				$s9{$k}/$total*100, $s9{$k},$_[0],$_[1]) if $i < $n;
				++$i
			}
		} else {
			foreach $k (sort { $s9{$b} <=> $s9{$a} } keys %s9) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %${hour_len}dh    %-${attack_len}s\n",
				$s9{$k}/$total*100, $s9{$k},$_[0],$_[1]) if $i < $n;
				++$i;
			}
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("Percentage and number of attacks by hour\n", "same_hour_attack");  
		if ($opt_i == 1) {
			foreach $k (sort { $s9{$a} <=> $s9{$b} } keys %s9) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %${hour_len}dh    %-${attack_len}s\n",
				$s9{$k}/$total*100, $s9{$k},$_[0],$_[1]) if $i < $n;
				++$i
			}
		} else {
			foreach $k (sort { $s9{$b} <=> $s9{$a} } keys %s9) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %${hour_len}dh    %-${attack_len}s\n",
				$s9{$k}/$total*100, $s9{$k},$_[0],$_[1]) if $i < $n;
				++$i;
			}
		}
	}
}
}


sub dport {
$i = 0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s16) ) ) {
	$n = keys %s16;
} else {
	$n = $val_opt_n;
}
if ( $opt_h == 1 ) {
	@list1 = ();
	@list2 = ();
	print FILEOUT ("<h3><CENTER><a name=\"dport\" HREF=\"#top\">Distribution of event by destination port</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=0 ALIGN=center><TR><TD><TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Destination Port</td></tr>");
	if ($opt_i == 1) {
		foreach $k (sort { $s16{$a} <=> $s16{$b} } keys %s16) {
			printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${port_len}s</td></tr>\n",
			$s16{$k}/$total*100, $s16{$k},$k) if ( $i < $n );
			push @list1 ,($s16{$k}) if ( $i < $n );
			push @list2 ,("$k") if ( $i < $n );
			++$i;
		}
	} else {
		foreach $k (sort { $s16{$b} <=> $s16{$a} } keys %s16) {
			printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${port_len}s</td></tr>\n",
			$s16{$k}/$total*100, $s16{$k},$k) if ( $i < $n );
			push @list1 ,($s16{$k}) if ( $i < $n );
			push @list2 ,("$k") if ( $i < $n );
			++$i;
		}
	}
	if ( $opt_g == 1 ) {
		init_graph("dport","pie");
		print FILEOUT ("</TABLE></TD><TD WIDTH=300 ALIGN=right><IMG SRC=".$graph_name._dport.".".$val_opt_g."></TD></TR></TABLE><BR>\n");
	} else {
		print FILEOUT ("</TABLE></TD></TR></TABLE><BR>\n");
	}
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "dport() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "Distribution of event by destination port\n";
		$linelength = 11 + $nb_len + 4 + $port_len + 4;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s16) ." ###\n");
		print FILEOUT ("    %    nb      Port\n");
		print FILEOUT ( '=' x $linelength, "\n");
		if ($opt_i == 1) {
			foreach $k (sort { $s16{$a} <=> $s16{$b} } keys %s16) {
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${port_len}s\n",
				$s16{$k}/$total*100, $s16{$k},$k) if ( $i < $n );
				++$i;
			}
		} else {
			foreach $k (sort { $s16{$b} <=> $s16{$a} } keys %s16) {
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${port_len}s  %-${attack_len}s\n",
				$s16{$k}/$total*100, $s16{$k},$k) if ( $i < $n );
				++$i;
			}
		}	
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("Distribution of event by destination port\n", "dport");  
		if ($opt_i == 1) {
			foreach $k (sort { $s16{$a} <=> $s16{$b} } keys %s16) {
				printf("  %5.2f  %-${nb_len}d  %-${port_len}s\n",
				$s16{$k}/$total*100, $s16{$k},$k) if ( $i < $n );
				++$i;
			}
		} else {
			foreach $k (sort { $s16{$b} <=> $s16{$a} } keys %s16) {
				printf("  %5.2f  %-${nb_len}d  %-${port_len}s  %-${attack_len}s\n",
				$s16{$k}/$total*100, $s16{$k},$k) if ( $i < $n );
				++$i;
			}
		}
	}
}
}




sub dport_attack {
$i = 0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s18) ) ) {
	$n = keys %s18;
} else {
	$n = $val_opt_n;
}
if ( $opt_h == 1 ) {
	print FILEOUT ("<h3><CENTER><a name=\"port_attack\" href=\"#top\">Percentage and number of attacks to one destination port</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Port</td><td>Attack</td></tr>");
	if ($opt_i == 1) {
		foreach $k (sort { $s18{$a} <=> $s18{$b} } keys %s18) {
			@_ = split ",",$k;
			printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${port_len}s</td><td>%-${attack_len}s</td></tr>\n",
			$s18{$k}/$total*100, $s18{$k},$_[0],$_[1]) if ( $i < $n );
			++$i;
		}
	} else {
		foreach $k (sort { $s18{$b} <=> $s18{$a} } keys %s18) {
			@_ = split ",",$k;
			printf FILEOUT ("<tr class=TB><td>%-2.2f</td><td>%-${nb_len}d</td><td>%-${port_len}s</td><td>%-${attack_len}s</td></tr>\n",
			$s18{$k}/$total*100, $s18{$k},$_[0],$_[1]) if ( $i < $n );
			++$i;
		}
	}
	print FILEOUT ("</table><BR>\n");
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "dport_attack() :\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "Percentage and number of attacks to one destination port\n";
		$linelength = 11 + $nb_len + 4 + $port_len + 4 +  $attack_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s18) ." ###\n");
		print FILEOUT ("    %    nb      Port   Attack\n");
		print FILEOUT ( '=' x $linelength, "\n");
		if ($opt_i == 1) {
			foreach $k (sort { $s18{$a} <=> $s18{$b} } keys %s18) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${port_len}s  %-${attack_len}s\n",
				$s18{$k}/$total*100, $s18{$k},$_[0],$_[1]) if ( $i < $n );
				++$i;
			}
		} else {
			foreach $k (sort { $s18{$b} <=> $s18{$a} } keys %s18) {
				@_ = split ",",$k;
				printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${port_len}s  %-${attack_len}s\n",
				$s18{$k}/$total*100, $s18{$k},$_[0],$_[1]) if ( $i < $n );
				++$i;
			}
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("Percentage and number of attacks to one destination port\n", "dport_attack");  
		if ($opt_i == 1) {
			foreach $k (sort { $s18{$a} <=> $s18{$b} } keys %s18) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %-${port_len}s  %-${attack_len}s\n",
				$s18{$k}/$total*100, $s18{$k},$_[0],$_[1]) if ( $i < $n );
				++$i;
			}
		} else {
			foreach $k (sort { $s18{$b} <=> $s18{$a} } keys %s18) {
				@_ = split ",",$k;
				printf("  %5.2f  %-${nb_len}d  %-${port_len}s  %-${attack_len}s\n",
				$s18{$k}/$total*100, $s18{$k},$_[0],$_[1]) if ( $i < $n );
				++$i;
			}
		}
	}
}
}




sub reasons {
$i = 0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s12) ) ) {
	$n = keys %s12;
} else {
	$n = $val_opt_n;
}
if ( $opt_h == 1 ) {
	print FILEOUT ("<h3><CENTER><a name=\"reasons\" href=\"#top\">Distribution by DROP reason</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Reasons</td></tr>");
        foreach $k (sort { $s12{$b} <=> $s12{$a} } keys %s12) {
                printf FILEOUT ("<TR CLASS=TB><TD>%2.2f</TD><TD>%-${nb_len}d</TD><TD>%-32s</TD></TR>\n", $s12{$k}/$total*100,$s12{$k},$k) if ( $i < $n );
		++$i;
        }
	print FILEOUT ("</table><BR>\n");
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "reasons() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "Distribution by DROP reasons\n";
		$linelength = 11 + $nb_len + 4 + $port_len + 4 +  $attack_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s12) ." ###\n");
		print FILEOUT ("    %    nb      Reasons\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort { $s12{$b} <=> $s12{$a} } keys %s12) {
			printf FILEOUT ("  %5.2f  %-${nb_len}d  %-50s\n", $s12{$k}/$total*100,$s12{$k},$k) if ( $i < $n );
			++$i;
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {
		section_header("Distribution by DROP reasons\n", "reasons");
		foreach $k (sort { $s12{$b} <=> $s12{$a} } keys %s12) {
			printf("  %5.2f  %-${nb_len}d  %-50s\n", $s12{$k}/$total*100,$s12{$k},$k) if ( $i < $n );
			++$i;
		}
	}
}
}



sub actions {
$i = 0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s14) ) ) {
	$n = keys %s14;
} else {
	$n = $val_opt_n;
}
if ( $opt_h == 1 ) {
	print FILEOUT ("<h3><CENTER><a name=\"actions\" href=\"#top\">Distribution by action</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Actions</td></tr>");
        foreach $k (sort { $s14{$b} <=> $s14{$a} } keys %s14) {
                printf FILEOUT ("<TR CLASS=TB><TD>%2.2f</TD><TD>%-${nb_len}d</TD><TD>%-32s</TD></TR>\n", $s14{$k}/$total*100,$s14{$k},$k) if ( $i < $n );
		++$i;
        }
	print FILEOUT ("</table><BR>\n");
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "actions() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "Distribution by actions\n";
		$linelength = 11 + $nb_len + 4 + $port_len + 4 +  $attack_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s14) ." ###\n");
		print FILEOUT ("    %    nb      Actions\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort { $s14{$b} <=> $s14{$a} } keys %s14) {
			printf FILEOUT ("  %5.2f  %-${nb_len}d  %-10s\n", $s14{$k}/$total*100,$s14{$k},$k) if ( $i < $n );
			++$i;
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {
		section_header("Distribution by actions\n", "actions");
		foreach $k (sort { $s14{$b} <=> $s14{$a} } keys %s14) {
			printf("  %5.2f  %-${nb_len}d  %-10s\n", $s14{$k}/$total*100,$s14{$k},$k) if ( $i < $n );
			++$i;
		}
	}
}
}






sub rules {
$i = 0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s21) ) ) {
	$n = keys %s21;
} else {
	$n = $val_opt_n;
}
if ( $opt_h == 1 ) {
	print FILEOUT ("<h3><CENTER><a name=\"rules\" href=\"#top\">Number of occurrences by rules</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Rules</td></tr>");
        foreach $k (sort { $s21{$b} <=> $s21{$a} } keys %s21) {
                printf FILEOUT ("<TR CLASS=TB><TD>%2.2f</TD><TD>%-${nb_len}d</TD><TD>%-32s</TD></TR>\n", $s21{$k}/$total*100,$s21{$k},$k) if ( $i < $n );
		++$i;
        }
	print FILEOUT ("</table><BR>\n");
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "rules() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "Number of occurrences by rules\n";
		$linelength = 11 + $nb_len + 4 + $port_len + 4 +  $attack_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s21) ." ###\n");
		print FILEOUT ("    %    nb      Rules\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort { $s21{$b} <=> $s21{$a} } keys %s21) {
			printf FILEOUT ("  %5.2f  %-${nb_len}d  %-4d\n", $s21{$k}/$total*100,$s21{$k},$k) if ( $i < $n );
			++$i;
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("Number of occurrences by rules\n", "rules");
		foreach $k (sort { $s21{$b} <=> $s21{$a} } keys %s21) {
			printf("  %5.2f  %-${nb_len}d  %-4d\n", $s21{$k}/$total*100,$s21{$k},$k) if ( $i < $n );
			++$i;
		}	
	}
}
}




sub same_src_dport {
$i = 0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s22) ) ) {
	$n = keys %s22;
} else {
	$n = $val_opt_n;
}
if ( $opt_h == 1 ) {
	print FILEOUT ("<h3><CENTER><a name=\"same_src_dport\" href=\"#top\">Number of occurrences gouped by IP source and destination port</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Ip Src</td><td>Dport</td></tr>");
        foreach $k (sort { $s22{$b} <=> $s22{$a} } keys %s22) {
		@_ = split ",",$k;
		printf FILEOUT ("<TR CLASS=TB><TD>%2.2f</TD><TD>%-${nb_len}d</TD><TD>%-${addr_len}s</TD><TD>%-5s</TD></TR>\n", $s22{$k}/$total*100,$s22{$k},$_[0],$_[1]) if ( $i < $n );
		++$i;
        }
	print FILEOUT ("</table><BR>\n");
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "same_src_dport() :\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "Number of occurrences gouped by IP source and destination port\n";
		$linelength = 11 + $nb_len + 4 + $port_len + 4 +  $attack_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s22) ." ###\n");
		print FILEOUT ("    %    nb      Ip Src           Dport\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort { $s22{$b} <=> $s22{$a} } keys %s22) {
			@_ = split ",",$k;
			printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-5s\n", $s22{$k}/$total*100,$s22{$k},$_[0],$_[1]) if ( $i < $n );
			++$i;
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("Number of occurrences gouped by IP source and destination port\n", "same_src_dport");
		foreach $k (sort { $s22{$b} <=> $s22{$a} } keys %s22) {
			@_ = split ",",$k;
			printf ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-5s\n", $s22{$k}/$total*100,$s22{$k},$_[0],$_[1]) if ( $i < $n );
			++$i;
		}	
	}
}
}




sub same_dst_dport {
$i = 0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s23) ) ) {
	$n = keys %s23;
} else {
	$n = $val_opt_n;
}
if ( $opt_h == 1 ) {
	print FILEOUT ("<h3><CENTER><a name=\"same_dst_dport\" href=\"#top\">Number of occurrences gouped by IP dest and destination port</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>Ip Dest</td><td>Dport</td></tr>");
        foreach $k (sort { $s23{$b} <=> $s23{$a} } keys %s23) {
		@_ = split ",",$k;
		printf FILEOUT ("<TR CLASS=TB><TD>%2.2f</TD><TD>%-${nb_len}d</TD><TD>%-${addr_len}s</TD><TD>%-5s</TD></TR>\n", $s23{$k}/$total*100,$s23{$k},$_[0],$_[1]) if ( $i < $n );
		++$i;
        }
	print FILEOUT ("</table><BR>\n");
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "same_dst_dport() :\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "Number of occurrences gouped by IP dest and destination port\n";
		$linelength = 11 + $nb_len + 4 + $port_len + 4 +  $attack_len;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### ". $n ." of ". keys(%s23) ." ###\n");
		print FILEOUT ("    %    nb      Ip Src           Dport\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort { $s23{$b} <=> $s23{$a} } keys %s23) {
			@_ = split ",",$k;
			printf FILEOUT ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-5s\n", $s23{$k}/$total*100,$s23{$k},$_[0],$_[1]) if ( $i < $n );
			++$i;
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("Number of occurrences gouped by IP dest and destination port\n", "same_dst_dport");
		foreach $k (sort { $s23{$b} <=> $s23{$a} } keys %s23) {
			@_ = split ",",$k;
			printf ("  %5.2f  %-${nb_len}d  %-${addr_len}s  %-5s\n", $s23{$k}/$total*100,$s23{$k},$_[0],$_[1]) if ( $i < $n );
			++$i;
		}	
	}
}
}














sub init_domains {
open(DOMAINS,$domains_file) or die "Can not open domain file: $domains_file $!\n";
$MaxDomain=0;
while (<DOMAINS>) {
	next if (/^$/ or /^#/);
	$Dots=1;
	($Code,$Description) = /(^\S+)\s+(.*)/;
	$Code =~ tr/A-Z/a-z/;
	$DomainName{$Code}="$Description";
	$Dots++ while $Code =~ /\./g;
	$MaxDomain=$Dots if ($Dots >$MaxDomain);
}
close(DOMAINS);
}



sub init_rules {
open(RULES,$rules_file) or die "Can not open rules file: $rules_file $!\n";
while (<RULES>) {
	next if (/^$/ or /^#/);
	($descr_attack,$link_attack) = /(^.+})\s+(.*)$/;
	$link{$descr_attack}="$link_attack";
}
close(RULES);
}



sub init_color {
my $LOG = shift;
my $COLOR;
if (($LOG eq "high") || ($LOG =~ /nresolved/)) {
	$COLOR="TBR";
} elsif ($LOG eq "unknown") {
	$COLOR="TBG";
} else {
	$COLOR="TB";
}
return ($COLOR)
}




sub init_url {
my $LOG = shift;
my $URL;
if ($LOG eq "bugtraq") {
	$URL="http://www.securityfocus.com/bid/";
} elsif ($LOG eq "arachnids") {
	$URL="http://www.whitehats.com/info/IDS";
} elsif ($LOG eq "cve") {
	$URL="http://cve.mitre.org/cgi-bin/cvename.cgi?name=";
} elsif ($LOG eq "nessus") {
	$URL="http://cgi.nessus.org/plugins/dump.php3?id=";
} elsif ($LOG eq "MCAFEE") {
	$URL="http://vil.nai.com/vil/content/v_";
} elsif ($LOG eq "url") {
	$URL="http://";
}
return ($URL);
}



sub init_monthday {
%monthday = qw (
	Jan 1
	Feb 2
	Mar 3
	Apr 4
	May 5
	Jun 6
	Jul 7
	Aug 8
	Sep 9
	Oct 10
	Nov 11
	Dec 12);
}



sub init_daymonth {
%daymonth = qw (
	1 Jan
	2 Feb
	3 Mar
	4 Apr
	5 May
	6 Jun
	7 Jul
	8 Aug
	9 Sep
	10 Oct 
	11 Nov
	12 Dec
	01 Jan
	02 Feb
	03 Mar
	04 Apr
	05 May
	06 Jun
	07 Jul
	08 Aug
	09 Sep);
}




sub search_date {
my $MONTH = shift;
my $DAY = shift;
my $HOUR = shift;
my $MIN = shift;
my $SEC = shift;

if ( $MONTH >= $maxmonth) {
	if ($MONTH > $maxmonth) {
		$maxday = 0; $maxhour = 0; $maxmin = 0; $maxsec = 0;
	} 
	if ($DAY >= $maxday) {
		if ($DAY > $maxday) {
			$maxhour = 0; $maxmin = 0; $maxsec = 0;
		} 
		if ( $HOUR >= $maxhour) {
			if ($HOUR > $maxhour) {
				$maxmin = 0; $maxsec = 0;
			} 
			if ($MIN >= $maxmin) {
				if ($MIN > $maxmin) {
					$maxsec = 0;
				} 
				if ($SEC >= $maxsec) {
					$maxmonth = $MONTH;
					$maxday = $DAY;
					$maxhour = $HOUR;
					$maxmin = $MIN;
					$maxsec = $SEC;
				}
			}
		}
	}
}


if ( $MONTH <= $minmonth) {
	if ($MONTH < $minmonth) {
	$minday = 31; $minhour = 23; $minmin = 59; $minsec = 59;
	} 
	if ($DAY <= $minday) {
		if ($DAY < $minday) {
			$minhour = 23; $minmin = 59; $minsec = 59;
		} 
		if ( $HOUR <= $minhour) {
			if ($HOUR < $maxhour) {
				$minmin = 59; $minsec = 59;
			} 
			if ($MIN <= $minmin) {
				if ($MIN < $minmin) {
					$minsec = 59;
				} 
				if ($SEC <= $minsec) {
					$minmonth = $MONTH;
					$minday = $DAY;
					$minhour = $HOUR;
					$minmin = $MIN;
					$minsec = $SEC;
				}
			}
		}
	}
}

}








# portscan (if enable -p switch)
# Please use '-A fast' to generate the log, so portscan() can process it.
# contributed by: Paul Bobby, <paul.bobby@lmco.com>
#                 Jian-Da Li, <jdli@freebsd.csie.nctu.edu.tw>
sub portscan {
my (%s1, %s2);
# to see how many times a host performs portscan
# used in portscan()
for $i (0 .. $#portscan) {
	$s41{"$portscan[$i]->[0]"}++;
}

$i = 0;
if ( ( $opt_n != 1 ) || ( $val_opt_n > keys(%s41) ) ) {
	$n = keys %s41;
} else {
	$n = $val_opt_n;
}

if ( $opt_h == 1 ) {
	print FILEOUT ("<h3><CENTER><a name=\"portscan\" href=\"#top\">Portscan List</a></CENTER></h3>\n");
	print FILEOUT ("<TABLE BORDER=1 ALIGN=center>\n");
	print FILEOUT ("<tr class=TH align=center><td>%</td><td>Nb</td><td>IP Source</td></tr>");
	foreach $k (sort { $s41{$b} <=> $s41{$a} } keys %s41) {
		printf FILEOUT ("<tr class=TB><TD>%-2.2f</TD><TD>%-${nb_len}d</TD><TD>%-${addr_len}s\n", $s41{$k}/$totalscan*100,$s41{$k},$k) if ( $i < $n );
		++$i;
	}
	print FILEOUT ("</table><BR>\n");
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "portscan() :\t\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT "Portscans performed to/from HOME_NET\n";
		$linelength = 40;
		print FILEOUT ( '=' x $linelength, "\n");
		print FILEOUT (" " x 4, "### Portscan List ###\n");
		print FILEOUT ("    %    nb     IP source\n");
		print FILEOUT ( '=' x $linelength, "\n");
		foreach $k (sort { $s41{$b} <=> $s41{$a} } keys %s41) {
			printf FILEOUT ("  %5.2f  %-4d   %-${addr_len}s\n", $s41{$k}/$totalscan*100,$s41{$k},$k) if ( $i < $n );
			++$i;
		}
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
		section_header("Portscans performed to/from HOME_NET\n", "portscan");
		foreach $k (sort { $s41{$b} <=> $s41{$a} } keys %s41) {
			printf("  %5.2f  %-6d  %-${addr_len}s\n", $s41{$k}/$totalscan*100,$s41{$k},$k) if ( $i < $n );
			++$i;
		}
	}
}
}

# anomsensor (if enable -n switch)
# This function process data generated by spp_anomsensor plug-in (SPADE)
# By Yen-Ming Chen <chenym@alumni.cmu.edu>
sub anomsensor {
my (%s7);
# to see how many times a host performs portscan
# used in anomsensor()
for $i (0 .. $#anores) {
$s7{"$anores[$i]->[1],$anores[$i]->[3],$anores[$i]->[4]"}++;
}
section_header("Anomaly detected by SPADE\n", "asdo");
foreach $k (sort { $s7{$b} <=> $s7{$a} } keys %s7) {
@_ = split(/,/,$k);
printf("   %-4d   %-${addr_len}s %-${addr_len}s\t%-6d\n", $s7{$k},$_[0],$_[1],$_[2]) if $s7{$k};
}
}

# print the footer (needed for html)
sub print_footer {
if ( $opt_h == 1 ) {
#	open (FILEOUT, ">>$val_opt_u$val_opt_h") or die "Can no access file : $val_opt_u$val_opt_h\n";
	print FILEOUT ("<CENTER>Generated by <A HREF=http://jeremy.chartier.free.fr/snortalog/>Snortalog</A> Version: $version (Date: $datever )</CENTER>\n");
	print FILEOUT ("<CENTER><A HREF=mailto:jeremy.chartier\@free.fr>Jrmy CHARTIER</A></CENTER>\n");
	print FILEOUT ("</BODY>\n</HTML>");
	close (FILEOUT);
} else {
	if ( $opt{x} ) {
		$scrolled_status->insert('end', "print_footer() :\t\t\t");
		open (FILEOUT, ">$tmpout_file") or die "Can not open file: $tmpout_file\n";
		print FILEOUT ("\n");
		print FILEOUT ("Version: $version\n");
		print FILEOUT ("Jrmy CHARTIER, <jeremy.chartier\@free.fr>\n");
		print FILEOUT ("Date: $datever\n");
		close (FILEOUT);
		open (FILEIN, "<$tmpout_file") or die "Can access file : $tmpout_file\n";
		while (<FILEIN>) {
			chomp $_;
			$scrolled_result->insert('end', "$_\n");
		}
		close (FILEIN);
		$scrolled_result->insert('end', "\n");
		$scrolled_status->insert('end', "OK\n");
	} else {	
print <<FootMessage

Version: $version
Jrmy CHARTIER, <jeremy.chartier\@free.fr>
Date: $datever
FootMessage
}
}
}


#
# resolve host name and cache it
#
sub resolve {
my $Address=shift;
my $Hostname;
if ($Address =~ /(\d+\.\d+\.\d+\.\d+)/) {
$Hostname = gethostbyaddr(inet_aton($Address),AF_INET) or $Hostname="unresolved";
}
return $Hostname;
}








# Use a title and a short code to write the section headers
# This is used in place of a FORMAT as this allows variable column widths
# contributed by: Ned Patterson, <jpatter@alum.mit.edu>
#
sub section_header {
my $linelength;
$title = shift; 
$report = shift;
$_ = shift;
print("\n\n$title");
# constant for method length for now
#  $linelenght = (/p/?7:0) + (/a/?20:0) + (/s/?$addr_len:0) +
#(/d/?$addr_len+3:0) + (/m/?20:0);
#$linelength = 36;
#  print( '=' x $linelength, "\n");

if ( $report eq "attack_src_resolve") {
	$linelength = 11 + $nb_len + 2 + $addr_len + 2 + $resolve_len + 2 + $domain_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s5) ." ###\n");
	print("    %    nb      IP source        Resolve                                             Domain\n");
} elsif ($report eq "domain_src") {
$linelength = 11 + $domain_len;
print( '=' x $linelength, "\n");
print(" " x 4, "### ". $val_opt_n ." of ". keys(%s40) ." ###\n");
print("    %    nb      Domain\n");
} elsif ($report eq "attack_dst_resolve") {
	$linelength = 11 + $nb_len + 2 + $addr_len + 2 + $resolve_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s6) ." ###\n");
	print("    %    nb      IP destination   Resolve\n");
} elsif ($report eq "attack") {
$linelength = 13 + $nb_len + 4 + $attack_len + 4 + $prior_len + 4 + $sever_len;
print( '=' x $linelength, "\n");
print(" " x 4, "### ". keys(%s4) ." of ". keys(%s4) ." ###\n");
print("    %    nb      Attack                                                           Priority Severity\n");
} elsif ($report eq "stateful") {
$linelength = 40;
print( '=' x $linelength, "\n");
print(" " x 4, "### ". $anomaly ." of ". $anomaly ." ###\n");
print("    %    nb      Preprocessor\n");
} elsif ($report eq "nids") {
$linelength = 50;
print( '=' x $linelength, "\n");
print(" " x 4, "### ". keys(%s13) ." of ". keys(%s13) ." ###\n");
print("    %    nb      Sondes\n");
} elsif ($report eq "proto") {
$linelength = 50;
print( '=' x $linelength, "\n");
print(" " x 4, "### ". keys(%s11) ." of ". keys(%s11) ." ###\n");
print("    %    nb      Protocoles\n");
} elsif ($report eq "interfaces") {
$linelength = 40;
print( '=' x $linelength, "\n");
print(" " x 4, "### ". keys(%s1) ." of ". keys(%s1) ." ###\n");
print("    %    nb      Interfaces\n");



#} elsif ($report eq "port") {
#$linelength = 30;
#print( '=' x $linelength, "\n");
#if ($opt{n}) {
#$nb = $opt{n};
#} else {
#$nb = keys(%s8);
#}
#print(" " x 4, "### ". keys(%s8) ." of ". keys(%s8) ." ###\n");
#print("    %      nb        Port\n");
} elsif ($report eq "same_class") {
$linelength = 13 + $nb_len + 4 + $class_len + 4 + $sever_len;
print( '=' x $linelength, "\n");
print(" " x 4, "### ". keys(%s10) ." of ". keys(%s10) ." ###\n");
print("    %    nb       Classification                                               Severity\n");
} elsif ($report eq "same_hour_attack") {
	$linelength = 11 + $nb_len + 4 + $hour_len + 4 + $attack_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s9) ." ###\n");
	print("    %    nb      Heure  Attack\n");
} elsif ($report eq "same_src_attack") {
	$linelength = 11 + $nb_len + 4 + $addr_len + 4 + $attack_len + 4 + $sever_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s2) ." ###\n");
	print("    %    nb      IP source        Attack                                                                  Severity\n");
} elsif ($report eq "same_dst_attack") {
	$linelength = 13 + $nb_len + 4 + $addr_len + 4 + $attack_len + 4 + $sever_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s3) ." ###\n");
	print("    %    nb      IP destination   Attack                                                                  Severity\n");
} elsif ($report eq "same_src_dst_attack") {
	$linelength = 13 + $nb_len + 4 + $addr_len + 4 + $addr_len + 4 + $attack_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s0) ." ###\n");
	print("    %    nb      IP source        IP destination   Attack\n");
} elsif ($report eq "dport_attack") {
	$linelength = 11 + $nb_len + 4 + $port_len + 4 +  $attack_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s18) ." ###\n");
	print("    %    nb      Port   Attack\n");
} elsif ($report eq "dport") {
	$linelength = 11 + $nb_len + 4 + $port_len + 4;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s16) ." ###\n");
	print("    %    nb      Port\n");
} elsif ($report eq "same_src_dport") {
	$linelength = 13 + $nb_len + 4 + 40;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s22) ." ###\n");
	print("    %    nb      IP Src           Dport\n");
} elsif ($report eq "same_dst_dport") {
	$linelength = 13 + $nb_len + 4 + 40;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s23) ." ###\n");
	print("    %    nb      IP Dest          Dport\n");
} elsif ($report eq "reasons") {
	$linelength = 13 + $nb_len + 4 + 40;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s12) ." ###\n");
	print("    %    nb      Reasons\n");
} elsif ($report eq "actions") {
	$linelength = 13 + $nb_len + 4 + 6;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s14) ." ###\n");
	print("    %    nb      Actions\n");
} elsif ($report eq "rules") {
	$linelength = 13 + $nb_len + 4 + 40;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s21) ." ###\n");
	print("    %    nb      Rules\n");
} elsif ($report eq "daily_event") {
	$linelength = 20 + $nb_len + 6 + $graph_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". keys(%s19) ." of ". keys(%s19) ." ###\n");
	print(" Day Month  nb         %    Graph\n");
} elsif ($report eq "hour") {
	$linelength = 13 + $nb_len + 2 + $hour_len + 2 + $graph_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". keys(%s7) ." of ". keys(%s7) ." ###\n");
	print("  Hour nb        %    Graph\n");
} elsif ($report eq "portscan") {
	$linelength = 40;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### Portscan List ###\n");
	print("    %    nb      IP source\n");
} elsif ($report eq "attack_dst") {
	$linelength = 13 + $nb_len + 4 + $addr_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s6) ." ###\n");
	print("    %    nb      IP destination\n");
} elsif ($report eq "attack_src") {
	$linelength = 13 + $nb_len + 4 + $addr_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". $n ." of ". keys(%s5) ." ###\n");
	print("    %    nb      IP source\n");
} elsif ($report eq "severity") {
	$linelength = 13 + $nb_len + 2 + $sever_len + 2 + $graph_len;
	print( '=' x $linelength, "\n");
	print(" " x 4, "### ". keys(%s20) ." of ". keys(%s20) ." ###\n");
	print("    %    nb      Severity Graph\n");
}
	print( '=' x $linelength, "\n");
}



# Put data $alert into matrix for further process
# INPUT: $alert
sub process_data() {
$self = shift;
# put those data into a big matrix
if ($self->{PLUGIN} eq "anomsensor") {
push @anores , [$self->{THR},$self->{SADDR},$self->{SPORT},
	    $self->{DADDR},$self->{DPORT}];
#$opt_n = 1;
} elsif ($self->{PLUGIN} eq "portscan") {
	push @portscan , [$self->{SADDR}];
#$opt_p = 1;
} elsif ($self->{TYPE} eq "sys" || $self->{TYPE} eq "alert" || 
	$self->{PLUGIN} eq "stream4" || $self->{PLUGIN} eq "bo" ||
	$self->{PLUGIN} eq "frag2" || $self->{PLUGIN} eq "snort_decoder" ) {
	$self->{SIG} =~ s/\:$//o;
	push @result , [$self->{MON},$self->{DAY},$self->{HOUR},$self->{MIN},
                   $self->{SEC},$self->{HOST},$self->{SIG},$self->{SADDR},
                   $self->{SPORT},$self->{DADDR},$self->{DPORT},$self->{CLASS},
		   $self->{PLUGIN},$self->{PRIORITY},$self->{SEVERITY},$self->{ETHER},
		   $self->{PROTO}, $self->{ACTION}, $self->{REASON}, $self->{RULE}];
    $lastwassnort = 1;
  } else {
    print STDERR "Unknown alert type plugin! $self->{TYPE}:$self->{PLUGIN} Skipped!\n" if $opt{d};
    return;
  }
#  1;
}


sub usage {
print <<Helpmsg
Usage: cat <alerts file> or <snort.rules> | $0 <stats options> <options>

Options:
-x                      Mode GUI
-r 			Resolve IP adresses	
-c 			Resolve domains	
-h <file.html>		Specify a HTML file
-u <directorie>         Specify a directorie	
-g <gif|png|jpg>        Graph output format	
-i 			Inverse the result	
-d 			Mode debug	
-n <integer>		Specify a number of line in the result
-ether <interface>	Specify an interface
-genref			Generate the reference rules file	
-help			View this help

Reports:
-src                      Top IPs sources
-dst                      Top IPs destination
-src_attack               Top IPs sources grouped by attack
-dst_attack               Top IPs destination grouped by attack
-src_dst_attack           Top alert grouped by IPs sources, Ips destination and attack
-attack                   Top attack
-class                    Top classification
-severity                 Top severity
-daily_event              Top number of attack grouped by day
-hour                     Top number of attack grouped by hour
-hour_attack              Top specific attack grouped by hour
-dport                    Top destination port
-proto                    Top protocoles
-dport_attack             Top destination port grouped by attack
-nids                     Top NIDS host
-stateful                 Top stateful problems
-interfaces               Top interfaces events 
-domain_src               Top of domain source
-portscan                 Top of portscan alert
-actions                  Top of firewall action (DROP, REJECT, ACCEPT, etc ...)
-rules                    Top number of DROP by rule (only Fw-1)
-reasons                  Top number of DROP reason (only Fw-1)
-src_dport                Top IPs sources grouped by destination port
-dst_dport                Top IPs destination grouped by destination port
-report                   All reports 

Helpmsg
;
print_footer();
exit 0;
}

